libname resu "c:\";

  /*  Program creating the working file D5part    */

  /*  Annual LFS - creation of one file per year  */
  /*  The original matched LFS files are named: APPA1994, APPA1995, ... APPA2002 */
  
%macro fichier(an=2001,an2=02);
 data EETRAV;set resu.APPA&an(KEEP=RG AG ADFE ACT ANCA ANCENTR OHTM OHTP SALRED SALFR
                                   DIPL DDIPL FI AIRE IMLOC NOI TN HH HT COHAB HORAIRE NAFG16	
                                   S STATUT CSE STAT2 LPRM TP M NBAGENF TYMEN90R STPL 
								   /*  Variables above come from the LFS file.
								   Variables below come from the match with the Dares-Urssaf   */
                                   CATEG2 MMRDT AARDT0 AARDTinc TROUVE SIRETrens); 
length SALPRIVE 3;SALPRIVE=(ACT='1' and STAT2='2' and STATUT not in ('41','42'));
length ACTOCC 3;ACTOCC=(ACT='1');
LENGTH AN $ 4;AN=&an;
LENGTH EXP SCO 6;IF ADFE='99' THEN do;EXP=0;SCO=AG-6;end;
       ELSE IF ADFE='00' THEN do;EXP=AG-16;SCO=0;end;
       ELSE IF '06'<=ADFE<='14' THEN do;EXP=AG-14;SCO=ADFE-6;end;
       ELSE do;EXP=AG-ADFE;SCO=ADFE-6;end;
length DURTRAV 8;if HH not in ('SP','  ') then DURTRAV=HH;
  else if HT>0 then DURTRAV= HT;

data EE&an;set EETRAV(where=(LPRM in ('1','2')));
       
data CONJOINTS;set EETRAV(drop=ANCENTR AN COHAB RG NOI M NBAGENF TYMEN90R OHTP OHTM
                        where=(LPRM in ('1','2')));
 LPRM=3-LPRM; 
rename AG=AGCJ ADFE=ADFECJ ACT=ACTCJ S=SCJ DIPL=DIPLCJ DDIPL=DDIPLCJ CSE=CSECJ
       FI=FICJ TN=TNCJ STATUT=STATUTCJ STAT2=STAT2CJ
       EXP=EXPCJ SCO=SCOCJ DURTRAV=DURTRAVCJ HH=HHCJ HT=HTCJ TP=TPCJ SALRED=SALREDCJ SALFR=SALFRCJ
       CATEG2=CATEG2CJ  ANCA=ANCACJ
       MMRDT=MMRDTcj AARDT0=AARDTCJ TROUVE=TROUVECJ AARDTinc=AARDTincCJ
       NAFG16=NAFG16CJ STPL=STPLcj 	HORAIRE=HORAIREcj
       ACTOCC=ACTOCCCJ SALPRIVE=SALPRIVEcj SIRETrens=SIRETrensCJ ;

proc sort data=CONJOINTS;by AIRE IMLOC LPRM;
proc sort data=EE&an;by AIRE IMLOC LPRM;

data APPAb&an;merge EE&an(in=_iee)
	            CONJOINTS(in=_conjoint);by AIRE IMLOC LPRM;
   if _iee;  
   if _conjoint; 
if AARDTInc=. then AARDTinc=0;
if TROUVE=. then TROUVE=0;
length SALARIE SALARIEcj 3 MOIS $ 2;
 SALARIE=(STAT2='2');SALARIEcj=(STAT2CJ='2');
 MOIS='03';
run;
%mend fichier;

%fichier(an=2002,an2=02);  
%fichier(an=2001,an2=01);
%fichier(an=2000,an2=00);


%macro fichierold(an=2001);
data EETRAV;set resu.APPA&an(KEEP=RG AG ADFE ACT ANCA ANCENTR OHTM OHTP SALRED SALFR
                                  DIPL DDIPL FI AIRE IMLOC NOI TN HH HT COHAB HORAIRE NAFG16
                                  S STATUT CSE STAT2 LPRM TP M NBAGENF TYMEN90R STPL 
                                  TROUVE AARDTinc SIRETrens	CATEG2 MMRDT AARDT0   ); 
length SALPRIVE 3;SALPRIVE=(ACT='1' and STAT2='2' and STATUT not in ('41','42'));
length ACTOCC 3;ACTOCC=(ACT='1');
LENGTH AN $ 4;AN=&an;
LENGTH EXP SCO 6;IF ADFE='99' THEN do;EXP=0;SCO=AG-6;end;
       ELSE IF ADFE='00' THEN do;EXP=AG-16;SCO=0;end;
       ELSE IF '06'<=ADFE<='14' THEN do;EXP=AG-14;SCO=ADFE-6;end;
       ELSE do;EXP=AG-ADFE;SCO=ADFE-6;end;
length DURTRAV 8;if HH not in ('SP','  ') then DURTRAV=HH;
  else if HT>0 then DURTRAV= HT;
rename ANCA=ANCA2;

data EE&an;set EETRAV(where=(LPRM in ('1','2')));
length ANCA $ 4;ANCA='19'!!ANCA2;
  if ANCA='19  ' then ANCA='    ';
drop ANCA2;
      
 
data CONJOINTS(drop=ANCA2);set EETRAV(drop=ANCENTR AN COHAB RG NOI M NBAGENF TYMEN90R OHTP OHTM 
                          where=(LPRM in ('1','2')));
 LPRM=3-LPRM; 
length ANCACJ $ 4;ANCACJ='19'!!ANCA2;
  if ANCACJ='19  ' then ANCACJ='    ';
rename AG=AGCJ ADFE=ADFECJ ACT=ACTCJ S=SCJ DIPL=DIPLCJ DDIPL=DDIPLCJ CSE=CSECJ
       FI=FICJ TN=TNCJ STATUT=STATUTCJ STAT2=STAT2CJ
       EXP=EXPCJ SCO=SCOCJ DURTRAV=DURTRAVCJ HH=HHCJ HT=HTCJ TP=TPCJ SALRED=SALREDCJ SALFR=SALFRCJ
       CATEG2=CATEG2CJ 
       MMRDT=MMRDTcj AARDT0=AARDTCJ TROUVE=TROUVECJ AARDTinc=AARDTincCJ
       NAFG16=NAFG16CJ  STPL=STPLcj  HORAIRE=HORAIREcj
       ACTOCC=ACTOCCCJ SALPRIVE=SALPRIVEcj SIRETrens=SIRETrensCJ ;

proc sort data=CONJOINTS;by AIRE IMLOC LPRM;
proc sort data=EE&an;by AIRE IMLOC LPRM;

data APPAb&an;merge EE&an(in=_iee )
	            CONJOINTS(in=_conjoint);by AIRE IMLOC LPRM;
   if _iee;  
   if _conjoint; 
if AARDTInc=. then AARDTinc=0;
if TROUVE=. then TROUVE=0;
length SALARIE SALARIEcj 3 MOIS $ 2;
 SALARIE=(STAT2='2');SALARIEcj=(STAT2CJ='2');
 if AN='1999' then MOIS='01';else MOIS='03';
run;
%mend fichierold;
  
%fichierold(an=1999);
%fichierold(an=1998);  
 
%macro fichieroldold(an=2001,an2=01);
data EETRAV;set resu.APPA&an(KEEP=RG AG ADFE ACT ANCA ANCENTR OHTM OHTP SALRED SALFR
                                  DIPL DDIPL FI AIRE IMLOC NOI TN HH HT COHAB NAFG16 HORAIRE 
                                  S STATUT CSE STAT2 LPRM TP M NBAGENF TYMEN90R STPL 	
                                  TROUVE AARDTinc  SIRETrens CATEG2  MMRDT AARDT0  ); 
length SALPRIVE 3;SALPRIVE=(ACT='1' and STAT2='2' and STATUT not in ('41','42'));
length ACTOCC 3;ACTOCC=(ACT='1');
LENGTH AN $ 4;AN=&an;
LENGTH EXP SCO 6;IF ADFE='99' THEN do;EXP=0;SCO=AG-6;end;
       ELSE IF ADFE='00' THEN do;EXP=AG-16;SCO=0;end;
       ELSE IF '06'<=ADFE<='14' THEN do;EXP=AG-14;SCO=ADFE-6;end;
       ELSE do;EXP=AG-ADFE;SCO=ADFE-6;end;
length DURTRAV 8;if HH not in ('SP','  ') then DURTRAV=HH;
  else if HT>0 then DURTRAV= HT;
rename ANCA=ANCA2;

data EE&an;set EETRAV(where=(LPRM in ('1','2')));
length ANCA $ 4;ANCA='19'!!ANCA2;
  if ANCA='19  ' then ANCA='    ';
drop ANCA2;
       
proc sort data=EE&an;by AIRE IMLOC;
data EE1;set EE&an(keep=AIRE IMLOC);by AIRE IMLOC;
 length NBOBS 3;retain NBOBS 0;
 if first.IMLOC then NBOBS=0;
 NBOBS=NBOBS+1;
  if last.IMLOC;

data EE1;set EE1;if NBOBS in (1,2);

data EE&an;merge EE&an EE1(in=_i1);by AIRE IMLOC;
   if _i1;
drop NBOBS;

data CONJOINTS(drop=ANCA2);set EETRAV(drop=ANCENTR RG AN  NOI M NBAGENF TYMEN90R OHTP OHTM COHAB
                          where=(LPRM in ('1','2')));
 LPRM=3-LPRM; 
length ANCACJ $ 4;ANCACJ='19'!!ANCA2;
  if ANCACJ='19  ' then ANCACJ='    ';
rename AG=AGCJ ADFE=ADFECJ ACT=ACTCJ S=SCJ DIPL=DIPLCJ DDIPL=DDIPLCJ CSE=CSECJ
       FI=FICJ TN=TNCJ STATUT=STATUTCJ STAT2=STAT2CJ
       EXP=EXPCJ SCO=SCOCJ DURTRAV=DURTRAVCJ HH=HHCJ HT=HTCJ TP=TPCJ SALRED=SALREDCJ SALFR=SALFRCJ
       CATEG2=CATEG2CJ 
       MMRDT=MMRDTcj AARDT0=AARDTCJ TROUVE=TROUVECJ AARDTinc=AARDTincCJ
       NAFG16=NAFG16CJ
       ACTOCC=ACTOCCCJ SALPRIVE=SALPRIVEcj SIRETrens=SIRETrensCJ STPL=STPLcj  HORAIRE=HORAIREcj ;

proc sort data=CONJOINTS;by AIRE IMLOC LPRM;
proc sort data=EE&an;by AIRE IMLOC LPRM;

data APPAb&an;merge EE&an(in=_iee)
	               CONJOINTS(in=_conjoint);by AIRE IMLOC LPRM;
   if _iee;  
   if _conjoint; 
if AARDTInc=. then AARDTinc=0;
if TROUVE=. then TROUVE=0;
length SALARIE SALARIEcj 3 MOIS $ 2;
 SALARIE=(STAT2='2');SALARIEcj=(STAT2CJ='2');
 MOIS='03';
run;
%mend fichieroldold;

%fichieroldold(an=1997,an2=97);
%fichieroldold(an=1996,an2=96);
%fichieroldold(an=1995,an2=95);
%fichieroldold(an=1994,an2=94);   


   
data FICTOTA;set APPAb1994 APPAb1995 APPAb1996 APPAb1997 APPAb1998 APPAb1999
                 APPAb2000 APPAb2001 APPAb2002;
length ANCTREATmonth ANCTREATyear ANCTREATmonthCJ ANCTREATyearCJ 8;
 ANCTREATmonth=(AN-AARDT0)*12+(MOIS-MMRDT);
 ANCTREATyear=(AN-AARDT0);
 ANCTREATmonthCJ=(AN-AARDTcj)*12+(MOIS-MMRDTcj);
 ANCTREATyearCJ=(AN-AARDTcj);
length PASSE0AV PASSE1AV PASSE2AV PASSE3AV 3;
 if (ANCTREATyear=0 and TROUVE=1) then PASSE0AV=1;else PASSE0AV=0;
 if (ANCTREATyear=1) then PASSE1AV=1; else PASSE1AV=0;
 if (ANCTREATyear=2) then PASSE2AV=1; else PASSE2AV=0;
 if (ANCTREATyear>=3) then PASSE3AV=1; else PASSE3AV=0;
length PASSE0AVcj PASSE1AVcj PASSE2AVcj PASSE3AVcj  3;
 if (ANCTREATyearCJ=0 and TROUVEcj=1) then PASSE0AVcj=1; else PASSE0AVcj=0;
 if (ANCTREATyearCJ=1) then PASSE1AVcj=1; else PASSE1AVcj=0;
 if (ANCTREATyearCJ=2) then PASSE2AVcj=1; else PASSE2AVcj=0;
 if (ANCTREATyearCJ>=3) then PASSE3AVcj=1; else PASSE3AVcj=0;
length PASSEIDEM PASSE1AP PASSE2AP PASSE3AP 3;
 if (ANCTREATyear=0) then PASSEIDEM=1; else PASSEIDEM=0;
 if (ANCTREATyear=-1) then PASSE1AP=1; else PASSE1AP=0;
 if (ANCTREATyear=-2) then PASSE2AP=1;  else PASSE2AP=0;
 if (-17<=ANCTREATyear<=-3) then PASSE3AP=1;else PASSE3AP=0;
length PASSEIDEMcj PASSE1APcj PASSE2APcj PASSE3APcj 3;
 if (ANCTREATyearCJ=0) then PASSEIDEMcj=1; else PASSEIDEMcj=0;
 if (ANCTREATyearCJ=-1 ) then PASSE1APcj=1; else PASSE1APcj=0;
 if (ANCTREATyearCJ=-2) then PASSE2APcj=1; else PASSE2APcj=0;
 if (-17<=ANCTREATyearCJ<=-3 ) then PASSE3APcj=1; else PASSE3APcj=0;
if SCO=. then do; if (S='1' and DDIPL=' ') then SCO=10;  
            else if (S='1' and DDIPL='1') then SCO=19;
			else if (S='1' and DDIPL='3') then SCO=16;
            else if (S='1' and DDIPL='4') then SCO=14;
			else if (S='1' and DDIPL='5') then SCO=11;
            else if (S='1' and DDIPL='6') then SCO=11;
			else if (S='1' and DDIPL='7') then SCO=8;
			else if (S='2' and DDIPL=' ') then SCO=11;
            else if (S='2' and DDIPL='1') then SCO=18;
			else if (S='2' and DDIPL='3') then SCO=15;
            else if (S='2' and DDIPL='4') then SCO=13;
			else if (S='2' and DDIPL='5') then SCO=11;
            else if (S='2' and DDIPL='6') then SCO=11;
			else if (S='2' and DDIPL='7') then SCO=8; end;
if SCOcj=. then do; if (Scj='1' and DDIPLcj=' ') then SCOcj=10;  
            else if (Scj='1' and DDIPLcj='1') then SCOcj=19;
			else if (Scj='1' and DDIPLcj='3') then SCOcj=16;
            else if (Scj='1' and DDIPLcj='4') then SCOcj=14;
			else if (Scj='1' and DDIPLcj='5') then SCOcj=11;
            else if (Scj='1' and DDIPLcj='6') then SCOcj=11;
			else if (Scj='1' and DDIPLcj='7') then SCOcj=8;
			else if (Scj='2' and DDIPLcj=' ') then SCOcj=11;
            else if (Scj='2' and DDIPLcj='1') then SCOcj=18;
			else if (Scj='2' and DDIPLcj='3') then SCOcj=15;
            else if (Scj='2' and DDIPLcj='4') then SCOcj=13;
			else if (Scj='2' and DDIPLcj='5') then SCOcj=11;
            else if (Scj='2' and DDIPLcj='6') then SCOcj=11;
			else if (Scj='2' and DDIPLcj='7') then SCOcj=8; end;
length SALREDconst SALREDconstcj 8;
        if AN='1990' then do;SALREDconst=SALRED/0.985;SALREDconstcj=SALREDcj/0.985;end;
   else if AN='1991' then do;SALREDconst=SALRED/1.023;SALREDconstcj=SALREDcj/1.023;end;
   else if AN='1992' then do;SALREDconst=SALRED/1.053;SALREDconstcj=SALREDcj/1.053;end;
   else if AN='1993' then do;SALREDconst=SALRED/1.076;SALREDconstcj=SALREDcj/1.076;end;
   else if AN='1994' then do;SALREDconst=SALRED/1.092;SALREDconstcj=SALREDcj/1.092;end;
   else if AN='1995' then do;SALREDconst=SALRED/1.112;SALREDconstcj=SALREDcj/1.112;end;
   else if AN='1996' then do;SALREDconst=SALRED/1.138;SALREDconstcj=SALREDcj/1.138;end;
   else if AN='1997' then do;SALREDconst=SALRED/1.15;SALREDconstcj=SALREDcj/1.15;end;
   else if AN='1998' then do;SALREDconst=SALRED/1.159;SALREDconstcj=SALREDcj/1.159;end;
   else if AN='1999' then do;SALREDconst=SALRED/(1.159*0.997);SALREDconstcj=SALREDcj/(1.159*0.997);end;
   else if AN='2000' then do;SALREDconst=SALRED/(1.159*1.017);SALREDconstcj=SALREDcj/(1.159*1.017);end;
   else if AN='2001' then do;SALREDconst=SALRED/(1.159*1.03); SALREDconstcj=SALREDcj/(1.159*1.03);end;
   else if AN='2002' then do;SALREDconst=SALRED/(1.159*1.05);SALREDconstcj=SALREDcj/(1.159*1.05);end;
length LOGSALRED 8;if SALRED>0 then LOGSALRED=log(1+SALREDconst); else LOGSALRED=0;
length LOGSALREDcj 8;if SALREDcj>0 then LOGSALREDcj=log(1+SALREDconstcj); else LOGSALREDcj=0;
length REG $ 2;REG=RG;
drop SALREDconst SALREDconstcj ANCTREATmonth ANCTREATyear ANCTREATmonthCJ ANCTREATyearCJ
     ADFE ADFEcj DIPL DIPLCj RG; run;

 

  /*  Creation of one file per year     */
  /*  The original matched LFS files are named: APPA20031, APPA20041, ... APPA20091 */

%macro fichier(an=2003);
data EETRAV(drop=EMPNBH);set resu.APPA&an.1(keep=EXTRI TRIM AG REG FORTER FORDAT ACTANC ACTEU DIP DDIPL IDENT NOI NAIA NBSALB 
                                                 HHC NBHP EMPNBH SALRED COHAB SEXE STATUT RGA CSE STAT2 LPR TPP TPPRED MATRI NBAGENF TYPMEN5
                                                 STPLC DATANT SALMEE NAFG16 CATEG2 MMRDT AARDT0 AARDTinc TROUVE SIRETrens);  
    if EXTRI>0 and ACTANC ne ' ';
length SALPRIVE 3;SALPRIVE=(ACTANC='1' and STAT2='2' and STATUT not in ('43','44','45'));
length ACTOCC 3;ACTOCC=(ACTANC='1');
LENGTH AN $ 4;AN=&an;
LENGTH EXP SCO 6;IF FORTER='2' THEN do;EXP=0;SCO=AG-6;end;
       ELSE IF FORTER='3' THEN do;EXP=AG-16;SCO=0;end;
       ELSE IF FORTER='1' THEN do;EXP=AN-FORDAT;SCO=FORDAT-(NAIA+6);end;
       ELSE do;EXP=AN-FORDAT;SCO=FORDAT-(NAIA+6);end;
  IF AG-EXP<=14 THEN EXP=AG-14;
length DURTRAV 8;DURTRAV=HHC;   
length HT $ 2;if EMPNBH=. then HT='  ';else if 0<=EMPNBH<=99.49 then HT=round(EMPNBH);
   else if 99.49<=EMPNBH<=110 then HT='99'; 
rename SEXE=S ACTANC=ACT;

 
data EE&an;set EETRAV(where=(LPR in ('1','2')));   

data CONJOINTS;set EETRAV(drop=EXTRI REG RGA AN COHAB NOI MATRI NBAGENF TYPMEN5 
                          where=(LPR in ('1','2')));
 LPR=3-LPR; 
rename AG=AGCJ FORTER=FORTERCJ FORDAT=FORDATCJ ACT=ACTCJ ACTEU=ACTEUCJ S=SCJ DIP=DIPCJ DDIPL=DDIPLCJ CSE=CSECJ
       NAIA=NAIACJ NBSALB=NBSALBCJ STATUT=STATUTCJ STAT2=STAT2CJ 	NAFG16=NAFG16CJ
       EXP=EXPCJ SCO=SCOCJ DURTRAV=DURTRAVCJ HHC=HHCCJ HT=HTCJ NBHP=NBHPCJ TPP=TPPCJ TPPRED=TPPREDCJ 
	   CATEG2=CATEG2CJ  DATANT=DATANTCJ
       MMRDT=MMRDTcj AARDT0=AARDTCJ TROUVE=TROUVECJ AARDTinc=AARDTincCJ
       STPLC=STPLCcj SALRED=SALREDCJ SALMEE=SALMEECJ
       ACTOCC=ACTOCCCJ SALPRIVE=SALPRIVEcj SIRETrens=SIRETrensCJ;

proc sort data=CONJOINTS;by TRIM IDENT LPR;
proc sort data=EE&an;by TRIM IDENT LPR;

data APPA&an;merge EE&an(in=_iee)
	               CONJOINTS(in=_conjoint);by TRIM IDENT LPR;
   if _iee;  
   if _conjoint; 
if AARDTInc=. then AARDTinc=0;
if TROUVE=. then TROUVE=0;
length SALARIE SALARIEcj 3 MOIS $ 2;
 SALARIE=(STAT2='2');SALARIEcj=(STAT2CJ='2');
 if TRIM='1' then MOIS='02'; else if TRIM='2' then MOIS='05'; else if TRIM='3' then MOIS='08'; else if TRIM='4' then MOIS='11';
drop EXTRI;
run;   

%mend fichier;

%fichier(an=2003); 
%fichier(an=2004); %fichier(an=2005);


%macro fichi06(an=2003);

data EETRAV(drop=EMPNBH);set resu.APPA&an.1(keep=EXTRI09 TRIM REG AG FORTER FORDAT ACTANC ACTEU DIP DDIPL IDENT NOI NAIA NBSALB 
                                                 HHC NBHP EMPNBH SALRED COHAB SEXE STATUT RGA CSE STAT2 LPR TPP TPPRED MATRI NBAGENF TYPMEN5 
                                                 STPLC DATANT SALMEE NAFG16 CATEG2  MMRDT AARDT0 AARDTinc TROUVE SIRETrens)     ;   
   if EXTRI09>0 and ACTANC ne ' ';
length SALPRIVE 3;SALPRIVE=(ACTANC='1' and STAT2='2' and STATUT not in ('43','44','45'));
length ACTOCC 3;ACTOCC=(ACTANC='1');
LENGTH AN $ 4;AN=&an;
LENGTH EXP SCO 6;IF FORTER='2' THEN do;EXP=0;SCO=AG-6;end;
       ELSE IF FORTER='3' THEN do;EXP=AG-16;SCO=0;end;
       ELSE IF FORTER='1' THEN do;EXP=AN-FORDAT;SCO=FORDAT-(NAIA+6);end;
       ELSE do;EXP=AN-FORDAT;SCO=FORDAT-(NAIA+6);end;
  IF AG-EXP<=14 THEN EXP=AG-14;
length DURTRAV 8;DURTRAV=HHC; 
length HT $ 2;if EMPNBH=. then HT='  ';else if 0<=EMPNBH<=99.49 then HT=round(EMPNBH);
   else if 99.49<=EMPNBH<=110 then HT='99'; 
rename SEXE=S EXTRI09=EXTRI ACTANC=ACT;

 
data EE&an;set EETRAV(where=(LPR in ('1','2')));  

data CONJOINTS;set EETRAV(drop=EXTRI REG RGA AN COHAB NOI MATRI NBAGENF TYPMEN5 
                          where=(LPR in ('1','2')));
 LPR=3-LPR; 
rename AG=AGCJ FORTER=FORTERCJ FORDAT=FORDATCJ ACT=ACTCJ ACTEU=ACTEUCJ S=SCJ DIP=DIPCJ DDIPL=DDIPLCJ CSE=CSECJ
       NAIA=NAIACJ NBSALB=NBSALBCJ STATUT=STATUTCJ STAT2=STAT2CJ 	DATANT=DATANTCJ
       EXP=EXPCJ SCO=SCOCJ DURTRAV=DURTRAVCJ HHC=HHCCJ  HT=HTCJ NBHP=NBHPCJ TPP=TPPCJ TPPRED=TPPREDCJ 
	   CATEG2=CATEG2CJ  NAFG16=NAFG16CJ
       MMRDT=MMRDTcj AARDT0=AARDTCJ TROUVE=TROUVECJ AARDTinc=AARDTincCJ
       STPLC=STPLCcj SALRED=SALREDCJ SALMEE=SALMEECJ
       ACTOCC=ACTOCCCJ SALPRIVE=SALPRIVEcj SIRETrens=SIRETrensCJ;

proc sort data=CONJOINTS;by TRIM IDENT LPR;
proc sort data=EE&an;by TRIM IDENT LPR;

data APPA&an;merge EE&an(in=_iee)
	               CONJOINTS(in=_conjoint);by TRIM IDENT LPR;
   if _iee;  
   if _conjoint; 
if AARDTInc=. then AARDTinc=0;
if TROUVE=. then TROUVE=0;
length SALARIE SALARIEcj 3 MOIS $ 2;
 SALARIE=(STAT2='2');SALARIEcj=(STAT2CJ='2');
 if TRIM='1' then MOIS='02'; else if TRIM='2' then MOIS='05'; else if TRIM='3' then MOIS='08'; else if TRIM='4' then MOIS='11';
drop EXTRI;
run;   
%mend fichi06;

%fichi06(an=2006); %fichi06(an=2007); %fichi06(an=2008);


%macro fichi09(an=2003);

data EETRAV(drop=EMPNBH);set resu.APPA&an.1(keep=EXTRI09 TRIM REG AG FORTER FORDAT ACTANC ACTEU DIP DDIPL IDENT NOI NAIA NBSALB 
                                    HHC  NBHP EMPNBH SALRED COHAB SEXE STATUT RGA CSE STAT2 LPR TPP TPPRED MATRI NBAGENF TYPMEN5
                                    STPLC DATANT SALMEE  NAFG16  CATEG2 MMRDT AARDT0 AARDTinc TROUVE SIRETrens )   ;   
   if EXTRI09>0 and ACTANC ne ' ';
length SALPRIVE 3;SALPRIVE=(ACTANC='1' and STAT2='2' and STATUT not in ('43','44','45'));
length ACTOCC 3;ACTOCC=(ACTANC='1');
LENGTH AN $ 4;AN=&an;
LENGTH EXP SCO 6;IF FORTER='2' THEN do;EXP=0;SCO=AG-6;end;
       ELSE IF FORTER='3' THEN do;EXP=AG-16;SCO=0;end;
       ELSE IF FORTER='1' THEN do;EXP=AN-FORDAT;SCO=FORDAT-(NAIA+6);end;
       ELSE do;EXP=AN-FORDAT;SCO=FORDAT-(NAIA+6);end;
  IF AG-EXP<=14 THEN EXP=AG-14;
length DURTRAV 8;DURTRAV=HHC; 
length HT $ 2;if EMPNBH=. then HT='  ';else if 0<=EMPNBH<=99.49 then HT=round(EMPNBH);
   else if 99.49<=EMPNBH<=110 then HT='99'; 
rename SEXE=S EXTRI09=EXTRI ACTANC=ACT IDENT=IDENTr;

data EE&an;set EETRAV(where=(LPR in ('1','2')));  

data CONJOINTS;set EETRAV(drop=EXTRI REG RGA  AN COHAB NOI MATRI NBAGENF TYPMEN5 
                          where=(LPR in ('1','2')));
 LPR=3-LPR; 
rename AG=AGCJ FORTER=FORTERCJ FORDAT=FORDATCJ ACT=ACTCJ ACTEU=ACTEUCJ S=SCJ DIP=DIPCJ DDIPL=DDIPLCJ CSE=CSECJ
       NAIA=NAIACJ  NBSALB=NBSALBCJ STATUT=STATUTCJ STAT2=STAT2CJ 	DATANT=DATANTCJ
       EXP=EXPCJ SCO=SCOCJ DURTRAV=DURTRAVCJ HHC=HHCCJ HT=HTCJ NBHP=NBHPCJ TPP=TPPCJ TPPRED=TPPREDCJ 
	   CATEG2=CATEG2CJ  NAFG16=NAFG16CJ
       MMRDT=MMRDTcj AARDT0=AARDTCJ TROUVE=TROUVECJ AARDTinc=AARDTincCJ
       STPLC=STPLCcj    SALRED=SALREDCJ SALMEE=SALMEECJ
       ACTOCC=ACTOCCCJ SALPRIVE=SALPRIVEcj SIRETrens=SIRETrensCJ;

proc sort data=CONJOINTS;by TRIM IDENTr LPR;
proc sort data=EE&an;by TRIM IDENTr LPR;

data APPA&an;merge EE&an(in=_iee)
	               CONJOINTS(in=_conjoint);by TRIM IDENTr LPR;
   if _iee;  
   if _conjoint; if AARDTInc=. then AARDTinc=0;
if TROUVE=. then TROUVE=0;
length SALARIE SALARIEcj 3 MOIS $ 2;
 SALARIE=(STAT2='2');SALARIEcj=(STAT2CJ='2');
 if TRIM='1' then MOIS='02'; else if TRIM='2' then MOIS='05'; else if TRIM='3' then MOIS='08'; else if TRIM='4' then MOIS='11';
drop EXTRI;
run;   
%mend fichi09;

%fichi09(an=2009);



data FICTOTC(rename=(LPR=LPRM));set APPA2003 APPA2004 APPA2005 APPA2006 APPA2007 APPA2008 APPA2009;
length ANCTREATmonth ANCTREATyear ANCTREATmonthCJ ANCTREATyearCJ 8;
 ANCTREATmonth=(AN-AARDT0)*12+(MOIS-MMRDT);
 ANCTREATyear=(AN-AARDT0);
 ANCTREATmonthCJ=(AN-AARDTcj)*12+(MOIS-MMRDTcj);
 ANCTREATyearCJ=(AN-AARDTcj);
length PASSE0AV PASSE1AV PASSE2AV PASSE3AV PASSE4AV PASSE5AV 3;
 if (ANCTREATyear=0 and TROUVE=1) then PASSE0AV=1;else PASSE0AV=0;
 if (ANCTREATyear=1) then PASSE1AV=1; else PASSE1AV=0;
 if (ANCTREATyear=2) then PASSE2AV=1; else PASSE2AV=0;  
 if (ANCTREATyear=3) then PASSE3AV=1; else PASSE3AV=0;
 if (ANCTREATyear=4) then PASSE4AV=1; else PASSE4AV=0;
 if (ANCTREATyear>=5) then PASSE5AV=1; else PASSE5AV=0;
length PASSE0AVcj PASSE1AVcj PASSE2AVcj PASSE3AVcj  3;
 if (ANCTREATyearCJ=0 and TROUVEcj=1) then PASSE0AVcj=1; else PASSE0AVcj=0;
 if (ANCTREATyearCJ=1) then PASSE1AVcj=1; else PASSE1AVcj=0;
 if (ANCTREATyearCJ=2) then PASSE2AVcj=1; else PASSE2AVcj=0;
 if (ANCTREATyearCJ>=3) then PASSE3AVcj=1; else PASSE3AVcj=0;
length PASSEIDEM PASSE1AP PASSE2AP PASSE3AP 3;
 if (ANCTREATyear=0) then PASSEIDEM=1; else PASSEIDEM=0;
 if (ANCTREATyear=-1) then PASSE1AP=1; else PASSE1AP=0;
 if (ANCTREATyear=-2) then PASSE2AP=1;  else PASSE2AP=0;
 if (-17<=ANCTREATyear<=-3) then PASSE3AP=1;else PASSE3AP=0;
length PASSEIDEMcj PASSE1APcj PASSE2APcj PASSE3APcj 3;
 if (ANCTREATyearCJ=0) then PASSEIDEMcj=1; else PASSEIDEMcj=0;
 if (ANCTREATyearCJ=-1 ) then PASSE1APcj=1; else PASSE1APcj=0;
 if (ANCTREATyearCJ=-2) then PASSE2APcj=1; else PASSE2APcj=0;
 if (-17<=ANCTREATyearCJ<=-3 ) then PASSE3APcj=1; else PASSE3APcj=0;
length IDENTI $ 8;
if AN='2009' then IDENTI=IDENTr;
  else IDENTI=IDENT!!' ';
if (SCO=. or SCO<0 or SCO>30) then do;
  if (S='1' and DDIPL=' ') then SCO=10;  
        else if (S='1' and DDIPL='1') then SCO=19;
		else if (S='1' and DDIPL='3') then SCO=16;
        else if (S='1' and DDIPL='4') then SCO=14;
		else if (S='1' and DDIPL='5') then SCO=11;
        else if (S='1' and DDIPL='6') then SCO=11;
		else if (S='1' and DDIPL='7') then SCO=8;
		else if (S='2' and DDIPL=' ') then SCO=11;
        else if (S='2' and DDIPL='1') then SCO=18;
		else if (S='2' and DDIPL='3') then SCO=15;
        else if (S='2' and DDIPL='4') then SCO=13;
		else if (S='2' and DDIPL='5') then SCO=11;
        else if (S='2' and DDIPL='6') then SCO=11;
		else if (S='2' and DDIPL='7') then SCO=8; end;
if (SCOcj=. or SCOcj<0 or SCOcj>30) then do;
  if (Scj='1' and DDIPLcj=' ') then SCOcj=10;  
        else if (Scj='1' and DDIPLcj='1') then SCOcj=19;
        else if (Scj='1' and DDIPLcj='3') then SCOcj=16;
        else if (Scj='1' and DDIPLcj='4') then SCOcj=14;
		else if (Scj='1' and DDIPLcj='5') then SCOcj=11;
        else if (Scj='1' and DDIPLcj='6') then SCOcj=11;
		else if (Scj='1' and DDIPLcj='7') then SCOcj=8;
		else if (Scj='2' and DDIPLcj=' ') then SCOcj=11;
        else if (Scj='2' and DDIPLcj='1') then SCOcj=18;
		else if (Scj='2' and DDIPLcj='3') then SCOcj=15;
        else if (Scj='2' and DDIPLcj='4') then SCOcj=13;
		else if (Scj='2' and DDIPLcj='5') then SCOcj=11;
        else if (Scj='2' and DDIPLcj='6') then SCOcj=11;
		else if (Scj='2' and DDIPLcj='7') then SCOcj=8; end;
length euro 8;euro=6.55957;
length SALREDconst SALREDconstcj 8;
  if AN='2003' then do;SALREDconst=euro*SALRED/(1.159*1.075); SALREDconstcj=euro*SALREDcj/(1.159*1.075);end;
   else if AN='2004' then do;SALREDconst=euro*SALRED/(1.159*1.087); SALREDconstcj=euro*SALREDcj/(1.159*1.087);end;
   else if AN='2005' then do;SALREDconst=euro*SALRED/(1.159*1.109); SALREDconstcj=euro*SALREDcj/(1.159*1.109);end;
   else if AN='2006' then do;SALREDconst=euro*SALRED/(1.159*1.1254);SALREDconstcj=euro*SALREDcj/(1.159*1.1254);end;
   else if AN='2007' then do;SALREDconst=euro*SALRED/(1.159*1.139); SALREDconstcj=euro*SALREDcj/(1.159*1.139);end;
   else if AN='2008' then do;SALREDconst=euro*SALRED/(1.159*1.1746);SALREDconstcj=euro*SALREDcj/(1.159*1.1746);end;
   else if AN='2009' then do;SALREDconst=euro*SALRED/(1.159*1.1781);SALREDconstcj=euro*SALREDcj/(1.159*1.1781);end;
length LOGSALRED 8;if SALRED>0 then LOGSALRED=log(1+SALREDconst); else LOGSALRED=0;
length LOGSALREDcj 8;if SALREDcj>0 then LOGSALREDcj=log(1+SALREDconstcj); else LOGSALREDcj=0;
drop IDENT IDENTr EURO SALREDconst SALREDconstcj  DIP FORTER FORDAT FORTERcj FORDATcj DIPcj ;
run;
 

   
data B9409;set FICTOTA(in=_i1) FICTOTC(in=_i2);
    if S ne SCJ; 
  if AARDTcj='2007' then AARDTcj='    ';
  if AARDT0='2007' then AARDT0='    ';
length AGE AGEcj 6;AGE=AG;AGEcj=AGcj;
length AGEcj2 8;AGEcj2=AGEcj*AGEcj;
length DURTRAVREF DURTRAVREFcj 8;
  DURTRAVREF=HT; if ACT in ('2','3') then DURTRAVREF=.;
  DURTRAVREFcj=HTcj; if ACTcj in ('2','3') then DURTRAVREFcj=.;
length DURTRAVREFtot 8;
  DURTRAVREFTOT=HT; if ACT in ('2','3')  then DURTRAVREFTOT=0;
length PASSEQUAND PASSEQUANDcj $ 14;
 if PASSE3AV=1 then PASSEQUAND=' avant   3 ans';
  else if PASSE2AV=1 then PASSEQUAND=' avant  2 ans';
  else if PASSE1AV=1 then PASSEQUAND=' avant 1 an ';
  else if PASSEidem=1 then PASSEQUAND=' en meme temps';
  else if PASSE1AP=1 then PASSEQUAND='aprs 1 an ';
  else if PASSE2AP=1 then PASSEQUAND='aprs 2 ans';
  else if PASSE3AP=1 then PASSEQUAND='aprs 3 ans';
  else if AARDTinc=1 then PASSEQUAND='date inconnue';
  else if (TROUVE not in (1,2) and (SIRETrens=1 or STAT2='1') and ACT='1') then PASSEQUAND='jamais ou n sal';
  else if (ACT='1' and SIRETrens=0) then PASSEQUAND='on ne sait pas'; 
 if PASSE3AVcj=1 then PASSEQUANDcj=' avant   3 ans';
  else if PASSE2AVcj=1 then PASSEQUANDcj=' avant  2 ans';
  else if PASSE1AVcj=1 then PASSEQUANDcj=' avant 1 an ';
  else if PASSEidemcj=1 then PASSEQUANDcj=' en meme temps';
  else if PASSE1APcj=1 then PASSEQUANDcj='aprs 1 an ';
  else if PASSE2APcj=1 then PASSEQUANDcj='aprs 2 ans';
  else if PASSE3APcj=1 then PASSEQUANDcj='aprs 3 ans';
  else if AARDTinccj=1 then PASSEQUANDcj='date inconnue';
  else if (TROUVEcj not in (1,2) and (SIRETrenscj=1 or STAT2cj='1') and ACTcj='1') then PASSEQUANDcj='jamais ou n sal';
  else if (ACTcj='1' and SIRETrenscj=0) then PASSEQUANDcj='on ne sait pas'; 
length SOUSECH4 SOUSECH4bis 3;
 SOUSECH4=(ACTcj='1' and STAT2cj='2'); 
 SOUSECH4bis=(ACTcj='1' and STAT2cj='2' and ACT='1');
length A1995-A2009 3;
 A1995=(AN='1995');A1996=(AN='1996');
 A1997=(AN='1997');A1998=(AN='1998');
 A1999=(AN='1999');A2000=(AN='2000');
 A2001=(AN='2001');A2002=(AN='2002');
 A2003=(AN='2003');A2004=(AN='2004');
 A2005=(AN='2005');A2006=(AN='2006');
 A2007=(AN='2007');A2008=(AN='2008');
 A2009=(AN='2009');
length ROBIEN AUBRY1 AUBRY2 3;
  ROBIEN=(CATEG2='0');
  AUBRY1=(CATEG2 in ('1','2','3','4'));
  AUBRY2=(CATEG2 in ('5','6','7','8','9'));
length ROBIENcj AUBRY1cj AUBRY2cj 3;
  ROBIENcj=(CATEG2cj='0');
  AUBRY1cj=(CATEG2cj in ('1','2','3','4'));
  AUBRY2cj=(CATEG2cj in ('5','6','7','8','9')); 
length TYPEENQ $ 3;if _i1 then TYPEENQ='EEA'; else if _i2 then TYPEENQ='EEC';
length longDURTRAV2 3; 
  longDURTRAV2=(DURTRAVref>44);
  if TYPEENQ='EEC' then do; if S='1' then longDURTRAV2=(DURTRAVREF-1.02>44);
       if S='2' then longDURTRAV2=(DURTRAVREF-1.41>44); end; 
length AARDTcjCOR AARDTCOR $ 4;
if (AARDTcj='2003' and 04<=MMRDTcj<=12) then AARDTcjCOR='2003';
 else if ((AARDTcj='2002' and 04<=MMRDTcj<=12) or (AARDTcj='2003' and MMRDTcj<=03)) then AARDTcjCOR='2002';
 else if ((AARDTcj='2001' and 04<=MMRDTcj<=12) or (AARDTcj='2002' and MMRDTcj<=03)) then AARDTcjCOR='2001';
 else if ((AARDTcj='2000' and 04<=MMRDTcj<=12) or (AARDTcj='2001' and MMRDTcj<=03)) then AARDTcjCOR='2000';
 else if ((AARDTcj='1999' and 02<=MMRDTcj<=12) or (AARDTcj='2000' and MMRDTcj<=03)) then AARDTcjCOR='1999';
 else if ((AARDTcj='1998' and 04<=MMRDTcj<=12) or (AARDTcj='1999' and MMRDTcj<=01)) then AARDTcjCOR='1998';
 else if ((AARDTcj='1997' and 04<=MMRDTcj<=12) or (AARDTcj='1998' and MMRDTcj<=03)) then AARDTcjCOR='1997';
 else if ((AARDTcj='1996' and 04<=MMRDTcj<=12) or (AARDTcj='1997' and MMRDTcj<=03)) then AARDTcjCOR='1996';
if (AARDT0='2003' and 04<=MMRDT<=12) then AARDTCOR='2003';
 else if ((AARDT0='2002' and 04<=MMRDT<=12) or (AARDT0='2003' and MMRDT<=03)) then AARDTCOR='2002';
 else if ((AARDT0='2001' and 04<=MMRDT<=12) or (AARDT0='2002' and MMRDT<=03)) then AARDTCOR='2001';
 else if ((AARDT0='2000' and 04<=MMRDT<=12) or (AARDT0='2001' and MMRDT<=03)) then AARDTCOR='2000';
 else if ((AARDT0='1999' and 02<=MMRDT<=12) or (AARDT0='2000' and MMRDT<=03)) then AARDTCOR='1999';
 else if ((AARDT0='1998' and 04<=MMRDT<=12) or (AARDT0='1999' and MMRDT<=01)) then AARDTCOR='1998';
 else if ((AARDT0='1997' and 04<=MMRDT<=12) or (AARDT0='1998' and MMRDT<=03)) then AARDTCOR='1997';
 else if ((AARDT0='1996' and 04<=MMRDT<=12) or (AARDT0='1997' and MMRDT<=03)) then AARDTCOR='1996';
length DATEpasse 3;
 if ((AARDTcjCOR='2003' and AARDTCOR='2003') or (AARDTcjCOR='2002' and AARDTCOR='2002')
      or (AARDTcjCOR='2001' and AARDTCOR='2001') or (AARDTcjCOR='2000' and AARDTCOR='2000')
      or (AARDTcjCOR='1999' and AARDTCOR='1999') or (AARDTcjCOR='1998' and AARDTCOR='1998')
      or (AARDTcjCOR='1997' and AARDTCOR='1997') or (AARDTcjCOR='1996' and AARDTCOR='1996')) then DATEpasse=1;
 else DATEpasse=0;
drop TRIM AG AGcj FI FIcj TYMEN90R HHC HHCcj TYPMEN5 
     PASSE0AV PASSE0AVcj PASSE1AP PASSE1APcj PASSE1AV PASSE1AVcj PASSE2AP PASSE2APcj PASSE2AV PASSE2AVcj 
     PASSE3AP PASSE3APcj PASSE3AV PASSE3AVcj PASSE4AV PASSE5AV SALMEE SALMEEcj HORAIREcj; run;

   

data DIFPAR;set B9409(where=(SOUSECH4=1 
                                      and DURTRAVrefTOT ne . and DURTRAVrefcj ne .  and 18<=AGE<=65 and 18<=AGEcj<=65
                                      and ((CATEG2cj in (1,2,3,4,5,6,7,8,9) and '1998'<=AARDTcj<='2002')
                                            or (ROBIENcj=1 and '1996'<=AARDTcj<='2002') or PASSEQUANDcj='jamais ou n sa') ));
length cjTREATEDRobien cjTREATEDAubry1 cjTREATEDAubry2 cjCONTROLE cjTREATED
       PostcjTREATEDRobien PostcjTREATEDAubry1 PostcjTREATEDAubry2 PostcjTREATED 3;
 cjTREATEDAubry1=(CATEG2cj in ('1','2','3','4'));
 cjTREATEDAubry2=(CATEG2cj in ('5','6','7','8','9'));
 cjTREATEDRobien=(Robiencj=1);
 cjTREATED=	cjTREATEDRobien + cjTREATEDAubry1 + cjTREATEDAubry2 ;
 cjCONTROLE=(PASSEQUANDcj='jamais ou n sa');
 PostcjTREATEDRobien=cjTREATEDRobien*((AN>'1995' and AARDTcj='1996' and '  '<=MMRDTcj<='03')
                                   or (AN>'1996' and ((AARDTcj='1996' and '04'<=MMRDTcj<='12') or (AARDTcj='1997' and '  '<=MMRDTcj<='03')))
                                   or (AN>'1997' and ((AARDTcj='1997' and '04'<=MMRDTcj<='12') or (AARDTcj='1998' and '  '<=MMRDTcj<='03')))  
                                   or (AN>'1998' and ((AARDTcj='1998' and '04'<=MMRDTcj<='12') or (AARDTcj='1999' and '  '<=MMRDTcj<='01')))
                                   or (AN>'1999' and ((AARDTcj='1999' and '02'<=MMRDTcj<='12') or (AARDTcj='2000' and '  '<=MMRDTcj<='03')))
                                   or (AN>'2000' and ((AARDTcj='2000' and '04'<=MMRDTcj<='12') or (AARDTcj='2001' and '  '<=MMRDTcj<='03')))
                                   or (AN>'2001' and ((AARDTcj='2001' and '04'<=MMRDTcj<='12') or (AARDTcj='2002' and '  '<=MMRDTcj<='03')))
                                   or (AN>'2002' and ((AARDTcj='2002' and '04'<=MMRDTcj<='12') or (AARDTcj='2003' and '  '<=MMRDTcj<='03')))
                                   or (AN>'2003' and ((AARDTcj='2003' and '04'<=MMRDTcj<='12') )));
 PostcjTREATEDAubry1=cjTREATEDAubry1*((AN>'1997' and AARDTcj='1998' and '  '<=MMRDTcj<='03')
                                   or (AN>'1998' and ((AARDTcj='1998' and '04'<=MMRDTcj<='12') or (AARDTcj='1999' and '  '<=MMRDTcj<='01')))
                                   or (AN>'1999' and ((AARDTcj='1999' and '02'<=MMRDTcj<='12') or (AARDTcj='2000' and '  '<=MMRDTcj<='03')))
                                   or (AN>'2000' and ((AARDTcj='2000' and '04'<=MMRDTcj<='12') or (AARDTcj='2001' and '  '<=MMRDTcj<='03')))
                                   or (AN>'2001' and ((AARDTcj='2001' and '04'<=MMRDTcj<='12') or (AARDTcj='2002' and '  '<=MMRDTcj<='03')))
                                   or (AN>'2002' and ((AARDTcj='2002' and '04'<=MMRDTcj<='12') or (AARDTcj='2003' and '  '<=MMRDTcj<='03')))
                                   or (AN>'2003' and ((AARDTcj='2003' and '04'<=MMRDTcj<='12') ))  );
 PostcjTREATEDAubry2=cjTREATEDAubry2*((AN>'1999' and ((AARDTcj='1999' and '02'<=MMRDTcj<='12') or (AARDTcj='2000' and '  '<=MMRDTcj<='03')))
                                   or (AN>'2000' and ((AARDTcj='2000' and '04'<=MMRDTcj<='12') or (AARDTcj='2001' and '  '<=MMRDTcj<='03')))
                                   or (AN>'2001' and ((AARDTcj='2001' and '04'<=MMRDTcj<='12') or (AARDTcj='2002' and '  '<=MMRDTcj<='03')))
                                   or (AN>'2002' and ((AARDTcj='2002' and '04'<=MMRDTcj<='12') or (AARDTcj='2003' and '  '<=MMRDTcj<='03')))
                                   or (AN>'2003' and ((AARDTcj='2003' and '04'<=MMRDTcj<='12') )) );
PostcjTREATED=PostcjTREATEDAubry1 + PostcjTREATEDAubry2 + PostcjTREATEDRobien;
length TREATEDRobien TREATEDAubry1 TREATEDAubry2 TREATEDAutre UNTREATED UNKNOWN  TREATED
       PostTREATEDRobien PostTREATEDAubry1 PostTREATEDAubry2 PostTREATED 3;
 TREATEDAubry1=(ACT='1' and AUBRY1=1 and '1998'<=AARDT0<='2002');
 TREATEDAubry2=(ACT='1' and AUBRY2=1 and '1999'<=AARDT0<='2002'); 
 TREATEDRobien=(ACT='1' and ROBIEN=1 and '1996'<=AARDT0<='2002'); 
 TREATED= TREATEDRobien + TREATEDAubry1 + TREATEDAubry2 ;
 TREATEDAutre=(ACT='1' and PASSEQUAND not in ('jamais ou n sa','on ne sait pas') and TREATEDAubry1=0 and TREATEDAubry2=0 and TREATEDRObien=0); 
 UNTREATED=(PASSEQUAND='jamais ou n sa' or ACT ne '1');
 UNKNOWN=(ACT='1' and PASSEQUAND='on ne sait pas'); 
 PostTREATEDAutre=TREATEDAutre*(   (AN>'1993' and ('1983'<=AARDT0<='1993' or (AARDT0='1994' and '  '<=MMRDT<='03')) )
                                or (AN>'1994' and ((AARDT0='1994' and '04'<=MMRDT<='12') or (AARDT0='1995' and '  '<=MMRDT<='03')))
                                or (AN>'1995' and ((AARDT0='1995' and '04'<=MMRDT<='12') or (AARDT0='1996' and '  '<=MMRDT<='03')))
                                or (AN>'1996' and ((AARDT0='1996' and '04'<=MMRDT<='12') or (AARDT0='1997' and '  '<=MMRDT<='03')))
                                or (AN>'1997' and ((AARDT0='1997' and '04'<=MMRDT<='12') or (AARDT0='1998' and '  '<=MMRDT<='03')))  
                                or (AN>'1998' and ((AARDT0='1998' and '04'<=MMRDT<='12') or (AARDT0='1999' and '  '<=MMRDT<='01')))
                                or (AN>'1999' and ((AARDT0='1999' and '02'<=MMRDT<='12') or (AARDT0='2000' and '  '<=MMRDT<='03')))
                                or (AN>'2000' and ((AARDT0='2000' and '04'<=MMRDT<='12') or (AARDT0='2001' and '  '<=MMRDT<='03')))
                                or (AN>'2001' and ((AARDT0='2001' and '04'<=MMRDT<='12') or (AARDT0='2002' and '  '<=MMRDT<='03')))
                                or (AN>'2002' and ((AARDT0='2002' and '04'<=MMRDT<='12') or (AARDT0='2003' and '  '<=MMRDT<='03')))
                                or (AN>'2003' and ((AARDT0='2003' and '04'<=MMRDT<='12') )) );
 PostTREATEDRobien=TREATEDRobien*((AN>'1995' and AARDT0='1996' and '  '<=MMRDT<='03')
                                or (AN>'1996' and ((AARDT0='1996' and '04'<=MMRDT<='12') or (AARDT0='1997' and '  '<=MMRDT<='03')))
                                or (AN>'1997' and ((AARDT0='1997' and '04'<=MMRDT<='12') or (AARDT0='1998' and '  '<=MMRDT<='03')))  
                                or (AN>'1998' and ((AARDT0='1998' and '04'<=MMRDT<='12') or (AARDT0='1999' and '  '<=MMRDT<='01')))
                                or (AN>'1999' and ((AARDT0='1999' and '02'<=MMRDT<='12') or (AARDT0='2000' and '  '<=MMRDT<='03')))
                                or (AN>'2000' and ((AARDT0='2000' and '04'<=MMRDT<='12') or (AARDT0='2001' and '  '<=MMRDT<='03')))
                                or (AN>'2001' and ((AARDT0='2001' and '04'<=MMRDT<='12') or (AARDT0='2002' and '  '<=MMRDT<='03')))
                                or (AN>'2002' and ((AARDT0='2002' and '04'<=MMRDT<='12') or (AARDT0='2003' and '  '<=MMRDT<='03')))
                                or (AN>'2003' and ((AARDT0='2003' and '04'<=MMRDT<='12') )) );
 PostTREATEDAubry1=TREATEDAubry1*((AN>'1997' and AARDT0='1998' and '  '<=MMRDT<='03')
                                or (AN>'1998' and ((AARDT0='1998' and '04'<=MMRDT<='12') or (AARDT0='1999' and '  '<=MMRDT<='01')))
                                or (AN>'1999' and ((AARDT0='1999' and '02'<=MMRDT<='12') or (AARDT0='2000' and '  '<=MMRDT<='03')))
                                or (AN>'2000' and ((AARDT0='2000' and '04'<=MMRDT<='12') or (AARDT0='2001' and '  '<=MMRDT<='03')))
                                or (AN>'2001' and ((AARDT0='2001' and '04'<=MMRDT<='12') or (AARDT0='2002' and '  '<=MMRDT<='03')))
                                or (AN>'2002' and ((AARDT0='2002' and '04'<=MMRDT<='12') or (AARDT0='2003' and '  '<=MMRDT<='03')))
                                or (AN>'2003' and ((AARDT0='2003' and '04'<=MMRDT<='12') )));
 PostTREATEDAubry2=TREATEDAubry2*((AN>'1999' and ((AARDT0='1999' and '02'<=MMRDT<='12') or (AARDT0='2000' and '  '<=MMRDT<='03')))
                               or (AN>'2000' and ((AARDT0='2000' and '04'<=MMRDT<='12') or (AARDT0='2001' and '  '<=MMRDT<='03')))
                               or (AN>'2001' and ((AARDT0='2001' and '04'<=MMRDT<='12') or (AARDT0='2002' and '  '<=MMRDT<='03')))
                               or (AN>'2002' and ((AARDT0='2002' and '04'<=MMRDT<='12') or (AARDT0='2003' and '  '<=MMRDT<='03')))
                               or (AN>'2003' and ((AARDT0='2003' and '04'<=MMRDT<='12') ))  );
 PostTREATED=PostTREATEDRobien + PostTREATEDAubry1 + PostTREATEDAubry2 + PostTREATEDAutre;
 if DURTRAVREF=. then DURTRAVREF=0;  
length cjYEARTREATED YEARTREATED $ 4;
  if ((AARDTcj='1996' and '04'<=MMRDTcj<='12') or (AARDTcj='1997' and '  '<=MMRDTcj<='03')) then cjYEARTREATED='1996';
   else if ((AARDTcj='1997' and '04'<=MMRDTcj<='12') or (AARDTcj='1998' and '  '<=MMRDTcj<='03')) then cjYEARTREATED='1997';
   else if ((AARDTcj='1998' and '04'<=MMRDTcj<='12') or (AARDTcj='1999' and '  '<=MMRDTcj<='01')) then cjYEARTREATED='1998';
   else if ((AARDTcj='1999' and '02'<=MMRDTcj<='12') or (AARDTcj='2000' and '  '<=MMRDTcj<='03')) then cjYEARTREATED='1999';
   else if ((AARDTcj='2000' and '04'<=MMRDTcj<='12') or (AARDTcj='2001' and '  '<=MMRDTcj<='03')) then cjYEARTREATED='2000';
   else if ((AARDTcj='2001' and '04'<=MMRDTcj<='12') or (AARDTcj='2002' and '  '<=MMRDTcj<='03')) then cjYEARTREATED='2001';
   else if ((AARDTcj='2002' and '04'<=MMRDTcj<='12') or (AARDTcj='2003' and '  '<=MMRDTcj<='03')) then cjYEARTREATED='2002';
   else if (AARDTcj='2003' and '04'<=MMRDTcj<='12') then cjYEARTREATED='2003';
  if ((AARDT0='1996' and '  '<=MMRDT<='03') or AARDT0<='1995') then YEARTREATED='1995';
   else if ((AARDT0='1996' and '04'<=MMRDT<='12') or (AARDT0='1997' and '  '<=MMRDT<='03')) then YEARTREATED='1996';
   else if ((AARDT0='1997' and '04'<=MMRDT<='12') or (AARDT0='1998' and '  '<=MMRDT<='03')) then YEARTREATED='1997';
   else if ((AARDT0='1998' and '04'<=MMRDT<='12') or (AARDT0='1999' and '  '<=MMRDT<='01')) then YEARTREATED='1998';
   else if ((AARDT0='1999' and '02'<=MMRDT<='12') or (AARDT0='2000' and '  '<=MMRDT<='03')) then YEARTREATED='1999';
   else if ((AARDT0='2000' and '04'<=MMRDT<='12') or (AARDT0='2001' and '  '<=MMRDT<='03')) then YEARTREATED='2000';
   else if ((AARDT0='2001' and '04'<=MMRDT<='12') or (AARDT0='2002' and '  '<=MMRDT<='03')) then YEARTREATED='2001';
   else if ((AARDT0='2002' and '04'<=MMRDT<='12') or (AARDT0='2003' and '  '<=MMRDT<='03')) then YEARTREATED='2002';
   else if (AARDT0>='2003') then YEARTREATED='2003';
length TREND 6;if cjTREATED=1 then TREND=AN-AARDTcj; else TREND=0;
length CADRE CADREcj 3; CADRE=('31'<=CSE<='38');CADREcj=('31'<=CSEcj<='38'); 
length NAFG16a NAFG16b NAFG16c NAFG16D NAFG16e NAFG16F NAFG16G NAFG16H
       NAFG16J NAFG16K NAFG16L NAFG16M NAFG16N NAFG16P NAFG16Q NAFG16R NAFG16inc 3;
 NAFG16a=(NAFG16='EA');   NAFG16b=(NAFG16='EB');
 NAFG16C=(NAFG16='EC');   NAFG16D=(NAFG16='ED');
 NAFG16E=(NAFG16='EE');   NAFG16F=(NAFG16='EF');
 NAFG16G=(NAFG16='EG');   NAFG16H=(NAFG16='EH');
 NAFG16J=(NAFG16='EJ');   NAFG16K=(NAFG16='EK');
 NAFG16L=(NAFG16='EL');   NAFG16M=(NAFG16='EM');
 NAFG16N=(NAFG16='EN');   NAFG16P=(NAFG16='EP');
 NAFG16Q=(NAFG16='EQ');   NAFG16R=(NAFG16='ER');
 NAFG16inc=(NAFG16 in ('  ','00'));
length NAFG16Acj NAFG16Bcj NAFG16Ccj NAFG16Dcj NAFG16ecj NAFG16Fcj NAFG16Gcj NAFG16Hcj
       NAFG16Jcj NAFG16Kcj NAFG16Lcj NAFG16Mcj NAFG16Ncj NAFG16Pcj NAFG16Qcj NAFG16Rcj NAFG16inccj 3;
 NAFG16Acj=(NAFG16cj='EA');   NAFG16Bcj=(NAFG16cj='EB');
 NAFG16Ccj=(NAFG16cj='EC');   NAFG16Dcj=(NAFG16cj='ED');
 NAFG16Ecj=(NAFG16cj='EE');   NAFG16Fcj=(NAFG16cj='EF');
 NAFG16Gcj=(NAFG16cj='EG');   NAFG16Hcj=(NAFG16cj='EH');
 NAFG16Jcj=(NAFG16cj='EJ');   NAFG16Kcj=(NAFG16cj='EK');
 NAFG16Lcj=(NAFG16cj='EL');   NAFG16Mcj=(NAFG16cj='EM');
 NAFG16Ncj=(NAFG16cj='EN');   NAFG16Pcj=(NAFG16cj='EP');
 NAFG16Qcj=(NAFG16cj='EQ');   NAFG16Rcj=(NAFG16cj='ER');
 NAFG16inccj=(NAFG16cj in ('  ','00'));
length ANCIENNETE  6;
 if TYPEENQ='EEC' then ANCIENNETE=AN-DATANT;  else if TYPEENQ='EEA'  then ANCIENNETE=AN-ANCA; 
length TPARTIEL 3;if (AN<='2002' and TP='2') or (AN>'2002' and TPPRED='2') then TPARTIEL=1;
  else if (AN<='2002' and TP='1') or (AN>'2002' and TPPRED='1') then TPARTIEL=0;  
length Ind_SALAIRE 3; Ind_SALAIRE=(AN<="2002" or (AN>='2003' and RGA in ('1','6'))); 
length DOUBLEDIF5 3;DOUBLEDIF5=(SOUSECH4bis=1 and DURTRAVref ne . );
length AGE2 8;AGE2=AGE*AGE;
  length IDENTNOI $ 17;
  if AN<='2002' then IDENTNOI='A'!!AIRE!!IMLOC!!NOI;
keep AN S DURTRAVref DURTRAVrefcj SCOcj AGEcj AGEcj2 REG IDENTNOI 
     DOUBLEDIF5 AARDTcjCOR TYPEENQ NBAGENF PASSEQUAND PASSEQUANDcj
	 TPARTIEL HH HHcj NBHP DURTRAV DURTRAVcj NAFG16 LOGSALRED LOGSALREDcj Ind_SALAIRE ACTOCC
     YEARTREATED ANCIENNETE CSE LONGDURTRAV2 CADRE CADREcj STATUT
     NAFG16Acj NAFG16Bcj NAFG16Ccj NAFG16Dcj NAFG16ecj NAFG16Fcj NAFG16Gcj
     NAFG16Hcj NAFG16Jcj NAFG16Kcj NAFG16Lcj  NAFG16Ncj NAFG16Pcj NAFG16Qcj NAFG16Rcj NAFG16inccj
     cjYEARTREATED SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009 TREND 
     TREATEDAutre TREATED UNKNOWN PostTREATED UNTREATED DATEpasse	
     SCO AGE AGE2 SALPRIVE NAFG16A NAFG16B NAFG16C NAFG16D NAFG16e NAFG16F NAFG16G 	 
     NAFG16H NAFG16J NAFG16K NAFG16L NAFG16N NAFG16P NAFG16Q NAFG16R NAFG16inc SALARIE;  run;

 
data resu.D5part; set DIFPAR;run;

