libname donn "c:\";


  /*  Program for Tables 1 to 7, Figures 1 and 8  */ 
  /*  and Web appendix Tables A1, C1,  D1, E2 and E5, Figures A1, A2, B5 */
   
 
data DD5part;set donn.D5part(keep=AN S DURTRAVref DURTRAVrefcj SCOcj AGEcj AGEcj2
                                  DOUBLEDIF5 AARDTcjCOR TYPEENQ NBAGENF 
	              TPARTIEL HH HHcj NBHP DURTRAV DURTRAVcj NAFG16 LOGSALRED LOGSALREDcj UNTREATED Ind_SALAIRE ACTOCC
                  YEARTREATED ANCIENNETE CSE LONGDURTRAV2 CADRE CADREcj STATUT
                  NAFG16Acj NAFG16Bcj NAFG16Ccj NAFG16Dcj NAFG16ecj NAFG16Fcj NAFG16Gcj
                  NAFG16Hcj NAFG16Jcj NAFG16Kcj NAFG16Lcj  NAFG16Ncj NAFG16Pcj NAFG16Qcj NAFG16Rcj NAFG16inccj
                  cjYEARTREATED SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009 TREND 
                  TREATEDAutre TREATED UNKNOWN PostTREATED DATEpasse	
                  SCO AGE AGE2 SALPRIVE NAFG16A NAFG16B NAFG16C NAFG16D NAFG16e NAFG16F NAFG16G 	
                  NAFG16H NAFG16J NAFG16K NAFG16L NAFG16N NAFG16P NAFG16Q NAFG16R NAFG16inc SALARIE); 
   /* all sample  */
length DURTRAVref0 3;DURTRAVref0=(DURTRAVREF=0);
length cjTREATEDtrend cjTREATEDtrend2 8;if cjTREATED=0 then cjTREATEDtrend=0;
   else if cjTREATED=1 then cjTREATEDtrend=cjTREATEd*(AN-AARDTcjCOR);
    if cjTREATED=0 then cjTREATEDtrend2=0;
   else if cjTREATED=1 then cjTREATEDtrend2=postcjTREATED*(AN-AARDTcjCOR);
length GROUPE3 $ 6;	if cjTREATED=0 then GROUPE3=AN!!'00';
   else if (cjTREATED=1 and postcjTREATED=0) then GROUPE3=AN!!'10';
   else if (cjTREATED=1 and postcjTREATED=1) then GROUPE3=AN!!'11';	


data DD5;set DD5part(where=(DOUBLEDIF5=1));    /* sample of employed persons */
length TPARTm30 3;if TPARTIEL=1 and AN<='2002' and ('01'<=HH<='30' or HH='SP') then TPARTm30=1 	;
  else if TPARTIEL=1 and AN>'2002' and NBHP<=30 then TPARTm30=1;
  else TPARTm30=0;
length DURDIFF DURDIFFcj 6 DURDIFF0 3;
  DURDIFF=DURTRAVREF-DURTRAV; 
  DURDIFFcj=DURTRAVREFcj-DURTRAVcj;	
  DURDIFF0=(DURDIFF=0);
length INDUSTRIEBTP 3;INDUSTRIEBTP=(NAFG16 in ('EB','EC','ED','EE','EF','EG','EH'));
length DUREE 6;
  if cjTREATED=1 then DUREE=AN-cjYEARTREATED; else DUREE=0;
run;   	

   	
proc sort data=DD5;by S cjTREATED; run; 
proc sort data=DD5part;by S cjTREATED;run;

%let suppvari=SCOcj AGEcj AGEcj2 NAFG16Acj NAFG16Bcj NAFG16Ccj NAFG16Dcj NAFG16ecj NAFG16Fcj NAFG16Gcj
              NAFG16Hcj NAFG16Jcj NAFG16Kcj NAFG16Lcj  NAFG16Ncj NAFG16Pcj NAFG16Qcj NAFG16Rcj NAFG16inccj;
%let suppvaric=SCOcj, AGEcj, AGEcj2 et NAFcj;

%let suppvari2=SCOcj AGEcj AGEcj2 ;
%let suppvari2c=SCOcj, AGEcj et AGEcj2;
   
%let suppvareg=SCO AGE AGE2 NAFG16A NAFG16B NAFG16C NAFG16D NAFG16e NAFG16F NAFG16G
              NAFG16H NAFG16J NAFG16K NAFG16L NAFG16N NAFG16P NAFG16Q NAFG16R NAFG16inc;
%let suppvareg2=SCO AGE AGE2;


   /* Figure 1 - Timing of implentation */
proc summary data=DD5part(where=(AN<='2002'));
var postcjTREATED;
class S AN;
output out=B(drop=_TYPE_ _FREQ_) mean=;
proc print data=B; title "Timing of implementation - all sample - Figure 1"; run;

proc export data=B outfile="c:\AER\Timing.xls" replace;
run;
 

  /* Table 1 - Distribution of own treatment, by spouse treatment */
proc means data=DD5(where=(UNKNOWN ne 1));
var TREATED TREATEDAutre UNTREATED datepasse;
by S cjTREATED;
title "Distribution of own firm status by firm status of the spouse";
title2 "(without individuals with unknown status of the firm)";
title3 "Table 1 (Panel A and Panel B)";
run;


  /* Table 2 - First stage regressions  */
proc SURVEYREG data=DD5part; 
cluster GROUPE3;
model DURTRAVREFcj=SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009;
by S; 
title "Field : full sample";
title2 "First stage on DURTRAVREFcj), with proc SURVEYREG";
title3 "Source : LFS, 1994-2009, Insee (Table 2, column 1)";

proc SURVEYREG data=DD5part; 
cluster GROUPE3;
model DURTRAVREFcj=SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009 &suppvari ;
by S; 
title3 "with supplementary controls : &suppvaric";
title4 "Source : LFS, 1994-2009, Insee (Table 2, column 2)";
 run;	

proc SURVEYREG data=DD5part(where=(Ind_SALAIRE=1)); 
cluster groupe3;
model LOGSALREDcj=SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009;
by S;
title2 "First stage on wage, with proc SURVEYREG"; 
title3 "Source : LFS, 1994-2009, Insee (Table 2, column 3)";

proc SURVEYREG data=DD5part(where=(Ind_SALAIRE=1)); 
cluster groupe3;
model LOGSALREDcj=SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009 &suppvari;
by S; 
title3 "with supplementary controls : &suppvaric";
title4 "Source : LFS, 1994-2009, Insee (Table 2, column 4)";run;

 proc means data=DD5part;
 var DURTRAVREFcj ;
 by S;
 title2 "Means for Table 2, columns 1 and 2";run;

 proc means data=DD5part(where=(Ind_SALAIRE=1));
 var LOGSALREDcj ;
 by S;
 title2 "Means for Table 2, columns 3 and 4";run;



   /* Table 3 - Reduced form regressions*/
proc SURVEYREG data=DD5part; 
cluster groupe3;
model ACTOCC=SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009;
by S;
title "Field : full sample";
title2 "Reduced-form on employment - with proc SURVEYREG";
title3 "Source : LFS, 1994-2009, Insee (Table 3, column 1) ";

proc SURVEYREG data=DD5part; 
cluster GROUPE3;
model ACTOCC=SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009 &suppvari2	&suppvareg2;
by S; 
title3 "with supplementary controls : &suppvareg2 &suppvari2c ";
title4 "Source : enqutes Emploi, 1994-2009, Insee (Table 3, column 2) ";run;

proc SURVEYREG data=DD5; 
cluster GROUPE3;
model DURTRAVREF=SALARIE  SALPRIVE SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009  
                 TREATEDAutre TREATED UNKNOWN  postTREATED;
by S;
title "Field : employed persons";
title2 "Reduced-form on DURTRAVREF";
title3 "Source : LFS, 1994-2009, Insee (Table 3, column 3) ";

proc SURVEYREG data=DD5; 
cluster GROUPE3;
model DURTRAVref=SALARIE SALPRIVE SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009  
                 TREATEDAutre TREATED UNKNOWN PostTREATED  &suppvari &suppvareg;
by S;
title3 "With supplementary controls : &suppvareg &suppvaric";
title4 "Source : LFS, 1994-2009, Insee (Table 3, column 4)"; run;
  
proc SURVEYREG data=DD5(where=(DATEpasse=0)); 
cluster groupe3;
model DURTRAVREF=SALARIE SALPRIVE SALPRIVEcj cjTREATED  PostcjTREATED A1995-A2009  
                 TREATED TREATEDAutre UNKNOWN postTREATED &suppvari &suppvareg;
by S;
title "Field : employed persons who were not treated at the same time as their spouse";	
title2 "Reduced-form on DURTRAVREF"; 
title3 "With supplementary controls : &suppvareg &suppvaric";
title4 "Source : LFS, 1994-2009, Insee (Table 3, column 5)";
run;

proc SURVEYREG data=DD5(where=(TREATED=0 and TREATEDautre=0)); 
cluster groupe3;
model DURTRAVREF=SALARIE SALPRIVE SALPRIVEcj cjTREATED  PostcjTREATED   
                 A1995-A2009     UNKNOWN &suppvari &suppvareg;
by S;
title "Field : employed persons who were never treated"; 
title2 "Reduced-form on DURTRAVREF"; 
title3 "With supplementary controls : &suppvareg &suppvaric";
title4 "Source : LFS, 1994-2009, Insee (Table 3, column 6)";
run;

proc means data=DD5part;
var ACTOCC; by S;
title "Means of dependent variables for Table 3, columns 1 and 2";run;

proc means data=DD5;
var DURTRAVref; by S;
title "Means of dependent variables for Table 3, columns 3 and 4";run;

proc means data=DD5(where=(DATEpasse=0));
var DURTRAVref; by S;
title "Means of dependent variables for Table 3, column 5";run; 

proc means data=DD5(where=(TREATED=0 and TREATEDautre=0));
var DURTRAVref; by S;
title "Means of dependent variables for Table 3, column 6";run;



 /* Figure B5 - differences in hours worked, controlling for characteristics */
data DOUBLEDIF2;set DD5;
length cjTREATEDm6-cjTREATEDm1 cjTREATED0 cjTREATEDp1-cjTREATEDp7 3;
array v(12)  cjTREATEDm5-cjTREATEDm1 cjTREATED0 cjTREATEDp1-cjTREATEDp6;
  do i=1 to 12;  v(i)=cjTREATED*(DUREE=i-6);  end;
cjTREATEDm6=cjTREATED*(DUREE<=-6);
cjTREATEDp7=cjTREATED*(DUREE>=7); 
length DUREEego 6; 
  if TREATED=1 then DUREEego=AN-YEARTREATED; else DUREEego=0;
length TREATEDm6-TREATEDm1 TREATED0 TREATEDp1-TREATEDp7 3;
array w(12) TREATEDm5-TREATEDm1 TREATED0 TREATEDp1-TREATEDp6;
  do i=1 to 12; w(i)=TREATED*(DUREEego=i-6);  end;
TREATEDm6=TREATED*(DUREEego<=-6);
TREATEDp7=TREATED*(DUREEego>=7);  
drop DUREEego;
run;	  


proc surveyreg data=DOUBLEDIF2 ; 
model DURTRAVref=SALARIE SALPRIVE SALPRIVEcj cjTREATEDm6-cjTREATEDm1 cjTREATED0 cjTREATEDp1-cjTREATEDp7 A1995-A2009 
                 TREATEDAutre  UNKNOWN   TREATEDm6-TREATEDm1 TREATED0 TREATEDp1-TREATEDp7
                 &suppvari &suppvareg ;
by S;  
ods output ParameterEstimates =FIGB5(where=(substr(Parameter,1,9)='cjTREATED') keep=S PArameter Estimate StdErr);
title "Field : employed persons";
title2 "Reduced-form, with supplementary controls : &suppvareg &suppvaric";
title3 "Source : LFS, 1994-2009, Insee (Figure B5)"; run;
   
proc export data=FIGB5 outfile="c:\AER\figb5.xls" replace;
run;


  /* Table 4 - Direct and cross-effects of the shorter workweek on hours worked */
data A;set DD5(where=(Ind_SALAIRE=1 and SALARIE=1 and AN<='2002' 
                             and HH not in ('SP','  ','99') and HHcj not in ('SP','  ','99')  )) ;
length  DURDIFFP DURDIFFM DURDIFFMtrav2 6;
 DURDIFFP=DURDIFF*(DURDIFF>=0); 
 DURDIFFM=DURDIFF*(DURDIFF<0);
 DURDIFFMtrav2=(DURDIFF<0)*(DURTRAVREF>0);
length PASTRAVAILLE 6;PASTRAVAILLE=(DURTRAVref=0); 

proc sort data=A;by S; run; 

proc SURVEYREG data=A; 
cluster GROUPE3;
model DURTRAVcj=SALPRIVEcj cjTREATED PostcjTREATED A1995-A2002 &suppvari; 
by S; 
title "Field : Employed persons with non missing own and spouse's usual hours, 1994-2002";
title2 "First stage on DURTRAVcj";
title3 "Table 4 (column 1) - Panels A and B"; 

proc SURVEYREG data=A; 
cluster GROUPE3;
model DURDIFFcj=SALPRIVEcj cjTREATED PostcjTREATED A1995-A2002 &suppvari ; 
by S;
title2 "First stage on DURDIFFcj";
title3 "Table 4 (column 2) - Panels A and B"; run;

proc SURVEYREG data=A; 
cluster GROUPE3;
model DURTRAV=SALPRIVE SALPRIVEcj cjTREATED PostcjTREATED A1995-A2002
              TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari &suppvareg; 
by S; 
title2 "Reduced form on DURTRAV";
title3 "Table 4 (column 3) - Panels A and B"; 

proc SURVEYREG data=A; 
cluster GROUPE3;
model DURDIFF=SALPRIVE SALPRIVEcj cjTREATED PostcjTREATED A1995-A2002
              TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari &suppvareg; 
by S; 
title2 "Reduced form on DURDIFF";
title3 "Table 4 (column 4) - Panels A and B"; run;


   /* Table 5 - Cross-effects of the shorter workweek on types of hours worked and earnings  */
proc SURVEYREG data=A; 
cluster GROUPE3;
model DURDIFFP=SALPRIVE SALPRIVEcj cjTREATED PostcjTREATED A1995-A2002
               TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari &suppvareg;  
by S; 
title2 "Reduced form on DURDIFFP";
title3 "Table 5 (column 1) - Panels A and B";

proc SURVEYREG data=A; 
cluster GROUPE3;
model DURDIFFM=SALPRIVE SALPRIVEcj cjTREATED PostcjTREATED A1995-A2002
               TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari &suppvareg; 
by S; 
title2 "Reduced form on DURDIFFM";
title3 "Table 5 (column 2) - Panels A and B"; 

proc SURVEYREG data=A; 
cluster GROUPE3;
model PASTRAVAILLE=SALPRIVE SALPRIVEcj cjTREATED PostcjTREATED A1995-A2002
                   TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari &suppvareg; 
by S; 
title2 "Reduced form on PASTRAVAILLE";
title3 "Table 5 (column 3) - Panels A and B"; 

proc SURVEYREG data=A; 
cluster GROUPE3;
model DURDIFFMtrav2=SALPRIVE SALPRIVEcj cjTREATED PostcjTREATED A1995-A2002
                    TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari &suppvareg; 
by S; 
title2 "Reduced form on DURDIFFtrav2";
title3 "Table 5 (column 4) - Panels A and B"; 
 
proc SURVEYREG data=A; 
cluster GROUPE3;
model TPARTIEL=SALPRIVE SALPRIVEcj cjTREATED PostcjTREATED A1995-A2002
                  TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari &suppvareg; 
by S; 
title2 "Reduced form on part time";
title3 "Table 5 (column 5) - Panels A and B"; 
run;

proc SURVEYREG data=A;  
cluster GROUPE3;
model LOGSALRED=SALPRIVE SALPRIVEcj cjTREATED PostcjTREATED A1995-A2002 
                TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari &suppvareg;
by S;
title2 "Reduced form on LOGSALRED";
title3 "Table 5 (column 6) - Panels A and B";  run;

proc MEANS data=A;
var DURTRAVcj DURDIFFcj DURTRAV DURDIFF DURDIFFP DURDIFFM PASTRAVAILLE DURDIFFMtrav2 TPARTIEL LOGSALRED;
by S;
title "Means for Tables 4 and 5";run;


 
  /* Table 6 - Heterogeneous effects of the shorter workweek, by occupation and family type */
proc SURVEYREG data=DD5(where=('31'<=CSE<='38')); 
cluster GROUPE3;
model DURTRAVREFcj=SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009 &suppvari;
by S;
title "Field : employed persons, managers, professionnals... ";
title2 "First stage on DURTRAVREFcj";
title3 "Source : LFS, 1994-2009, Insee (Table 6, column 1, Panels A and B)";

proc SURVEYREG data=DD5(where=('31'<=CSE<='38')); 
cluster GROUPE3;
model DURTRAVREF=SALARIE SALPRIVE SALPRIVEcj  cjTREATED PostcjTREATED A1995-A2009
                 TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari &suppvareg;
by S;
title2 "Reduced form on work duration";
title3 "Source : LFS, 1994-2009, Insee (Table 6, column 2, Panels A and B)";

proc SURVEYREG data=DD5(where=('31'<=CSE<='38')); 
cluster GROUPE3;
model longDURTRAV2=SALARIE SALPRIVE SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009
                   TREATEDAutre TREATED UNKNOWN PostTREATED &suppvari &suppvareg;
by S;
title2 "Reduced form on long workweeks (>= 45 h/week)";
title3 "Source : LFS, 1994-2009, Insee (Table 6, column 3, Panels A and B)";run;

proc means data=DD5(where=('31'<=CSE<='38'));
var DURTRAVREFcj DURTRAVREF longDURTRAV2;
by S;
title "Means for Table 6, columns 1 to 3, Panels A and B";run;


proc SURVEYREG data=DD5(where=((CSE<'31' or CSE>'38'))); 
cluster GROUPE3;
model DURTRAVREFcj=SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009 &suppvari;
by S;
title "Field : employed persons, who are not managers, professionnals... ";
title2 "First stage on DURTRAVREFcj";
title3 "Source : LFS, 1994-2009, Insee (Table 6, column 4, Panels A and B)"; 

proc SURVEYREG data=DD5(where=((CSE<'31' or CSE>'38'))); 
cluster GROUPE3;
model DURTRAVREF=SALARIE SALPRIVE SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009 
                 TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari &suppvareg;
by S;
title2 "Reduced for on work duration";
title3 "Source : LFS, 1994-2009, Insee (Table 6, column 5, Panels A and B)"; 

proc SURVEYREG data=DD5(where=((CSE<'31' or CSE>'38'))); 
cluster GROUPE3;
model longDURTRAV2=SALARIE SALPRIVE SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009
                   TREATEDAutre TREATED UNKNOWN PostTREATED &suppvari &suppvareg;
by S;
title2 "Reduced form on long workweeks (>= 45 h/week)";
title3 "Source : LFS, 1994-2009, Insee (Table 6, column 6, Panels A and B)";run;

proc means data=DD5(where=(CSE<'31' or CSE>'38'));
var DURTRAVREFcj DURTRAVREF longDURTRAV2;
by S;
title "Means for Table 6, columns 4 to 6, Panels A and B";run;

 
proc SURVEYREG data=DD5(where=(NBAGENF in ('2','3','5','6','8','9'))); 
cluster GROUPE3;
model DURTRAVREFcj=SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009 &suppvari;  by S;
title "Field : employed persons with at least one child aged 0-6";
title2 "First stage on DURTRAVREFcj";
title3 "Source : LFS, 1994-2009, Insee (Table 6, column 1, Panels C and D)";

proc SURVEYREG data=DD5(where=(NBAGENF in ('2','3','5','6','8','9'))); 
cluster GROUPE3;
model DURTRAVREF=SALARIE SALPRIVE SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009 
                 TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari &suppvareg; by S;
title2 "Reduced form on work duration";
title3 "Source : LFS, 1994-2009, Insee (Table 6, column 2, Panels C and D)"; 

proc SURVEYREG data=DD5(where=(NBAGENF in ('2','3','5','6','8','9'))); 
cluster GROUPE3;
model longDURTRAV2=SALARIE SALPRIVE SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009
                   TREATEDAutre TREATED UNKNOWN PostTREATED &suppvari &suppvareg;  by S;
title2 "Reduced form on long workweeks (>= 45 h/week)";
title3 "Source : LFS, 1994-2009, Insee (Table 6, column 3, Panels C and D)";run;

proc means data=DD5(where=(NBAGENF in ('2','3','5','6','8','9')));
var DURTRAVREFcj DURTRAVREF longDURTRAV2;
by S;
title "Means for Table 6, columns 1 to 3, Panels C and D";run;


proc SURVEYREG data=DD5(where=(NBAGENF not in ('2','3','5','6','8','9'))); 
cluster GROUPE3;
model DURTRAVREFcj=SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009 &suppvari; by S;
title "Field : employed persons with no children aged 0-6";
title2 "First stage on DURTRAVREFcj";
title3 "Source : LFS, 1994-2009, Insee (Table 6, column 4, Panels C and D)"; 

proc SURVEYREG data=DD5(where=(NBAGENF not in ('2','3','5','6','8','9'))); 
cluster GROUPE3;
model DURTRAVREF=SALARIE SALPRIVE SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009 
                 TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari &suppvareg; by S;
title2 "Reduced form on work duration";
title3 "Source : LFS, 1994-2009, Insee (Table 6, column 5, Panels C and D)"; 

proc SURVEYREG data=DD5(where=(NBAGENF not in ('2','3','5','6','8','9'))); 
cluster GROUPE3;
model longDURTRAV2=SALARIE SALPRIVE SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009 
                   TREATEDAutre TREATED UNKNOWN PostTREATED &suppvari &suppvareg;  by S;
title2 "Reduced form on long workweeks (>= 45 h/week)";
title3 "Source : LFS, 1994-2009, Insee (Table 6, column 6, Panels C and D)";
run; 

proc means data=DD5(where=(NBAGENF not in ('2','3','5','6','8','9')));
var DURTRAVREFcj DURTRAVREF longDURTRAV2;
by S;
title "Means for Table 6, columns 4 to 6, Panels C and D";run;


  /* Table 7 - IV estimates of cross-hour effects */
proc REG data=DD5 noprint;
model DURTRAVREFcj= SALARIE SALPRIVE SALPRIVEcj  cjTREATED PostcjTREATED A1995-A2009
                   TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari &suppvareg;
by S;
output out=ETAPE11 predicted=PREDDURTRAVREFcj;
  
proc SURVEYREG data=ETAPE11;
cluster GROUPE3;
model DURTRAVREF=SALARIE SALPRIVE SALPRIVEcj cjTREATED PREDDURTRAVREFcj A1995-A2009 
                 TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari &suppvareg;
by S;
title "Field : employed persons";
title2 "Source : LFS, 1994-2009, Insee (Table 7, column 1)";
title3 "IV : Instrumentation of DURTRAVREFcj by PostcjTREATED"; run;


proc REG data=DD5(where=('31'<=CSE<='38')) noprint;
model DURTRAVREFcj= SALARIE SALPRIVE SALPRIVEcj  cjTREATED PostcjTREATED A1995-A2009
              TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari &suppvareg;
by S;
output out=ETAPE12 predicted=PREDDURTRAVREFcj;
  
proc SURVEYREG data=ETAPE12;
cluster GROUPE3;
model DURTRAVREF=SALARIE SALPRIVE SALPRIVEcj cjTREATED PREDDURTRAVREFcj A1995-A2009 
                 TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari &suppvareg;
by S;
title "Field : employed persons, managers, professionals, ... ";
title2 "Source : LFS, 1994-2009, Insee (Table 7, column 2)";
title3 "IV : Instrumentation of DURTRAVREFcj by PostcjTREATED"; run;
   

proc REG data=DD5(where=((CSE<'31' or CSE>'38') )) noprint;
model DURTRAVREFcj= SALARIE SALPRIVE SALPRIVEcj  cjTREATED PostcjTREATED A1995-A2009
              TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari &suppvareg;
by S;
output out=ETAPE13 predicted=PREDDURTRAVREFcj;
  
proc SURVEYREG data=ETAPE13;
cluster GROUPE3;
model DURTRAVREF=SALARIE SALPRIVE SALPRIVEcj cjTREATED PREDDURTRAVREFcj A1995-A2009 
                 TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari &suppvareg;
by S; 
title "Field : employed persons, who are not managers, professionals, ... ";
title2 "Source : LFS, 1994-2009, Insee (Table 7, column 3)";
title3 "IV : Instrumentation of DURTRAVREFcj by PostcjTREATED"; run;run;


proc REG data=DD5(where=(NBAGENF in ('2','3','5','6','8','9'))) noprint;
model DURTRAVREFcj=SALARIE SALPRIVE SALPRIVEcj  cjTREATED PostcjTREATED A1995-A2009
                   TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari &suppvareg;
by S;
output out=ETAPE14 predicted=PREDDURTRAVREFcj;
  
proc SURVEYREG data=ETAPE14;
cluster GROUPE3;
model DURTRAVREF=SALARIE SALPRIVE SALPRIVEcj cjTREATED PREDDURTRAVREFcj A1995-A2009 
                 TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari &suppvareg;
by S; 
title "Field : employed persons, with at least one child aged 0-6";
title2 "Source : LFS, 1994-2009, Insee (Table 7, column 4)";
title3 "IV : Instrumentation of DURTRAVREFcj by PostcjTREATED"; run;


proc REG data=DD5(where=(NBAGENF not in ('2','3','5','6','8','9'))) noprint;
model DURTRAVREFcj= SALARIE SALPRIVE SALPRIVEcj  cjTREATED PostcjTREATED A1995-A2009
                   TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari &suppvareg;
by S;
output out=ETAPE15 predicted=PREDDURTRAVREFcj;
  
proc SURVEYREG data=ETAPE15;
cluster GROUPE3;
model DURTRAVREF=SALARIE SALPRIVE SALPRIVEcj cjTREATED PREDDURTRAVREFcj A1995-A2009 
                 TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari &suppvareg;
by S; 
title "Field : employed persons, with no children aged 0-6";
title2 "Source : LFS, 1994-2009, Insee (Table 7, column 5)";
title3 "IV : Instrumentation of DURTRAVREFcj by PostcjTREATED"; run;
  

  /* Figure 8 - Estimated cross effects on the cumulative distribution function of hours */
data AA;set DD5;
length DURTRAVrefsup00-DURTRAVrefsup49 3;
array aa(50) DURTRAVrefsup00-DURTRAVrefsup49;
 do i=1 to 50; aa(i)=(DURTRAVref>i-1); end;
keep DURTRAVrefsup15-DURTRAVrefsup49 GROUPE3 S
     SALARIE SALPRIVE SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009
     TREATEDAutre TREATED UNKNOWN PostTREATED  &suppvari &suppvareg;run;
  

%macro formred(vardep,nomm);
proc SURVEYREG data=AA ; 
cluster GROUPE3;
model &vardep=SALARIE SALPRIVE SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009
              TREATEDAutre TREATED UNKNOWN PostTREATED &suppvari &suppvareg;
by S;  
ods output ParameterEstimates =REZ(where=(Parameter='PostcjTREATED') keep=S PArameter Estimate StdErr);
title "Field : employed persons";
title2 "Reduced form on  &vardep, with supplemntary controls : &suppvareg &suppvaric";
title3 "Source : LFS, 1994-2009, Insee (Figure 8)"; run;

data FigB&vardep;set REZ;
length EFFET 6;EFFET=&nomm; run;
%mend formred;

%formred(DURTRAVrefsup15,15);  
%formred(DURTRAVrefsup16,16);	
%formred(DURTRAVrefsup17,17); 
%formred(DURTRAVrefsup18,18);	
%formred(DURTRAVrefsup19,19);	
%formred(DURTRAVrefsup20,20); 
%formred(DURTRAVrefsup21,21);	
%formred(DURTRAVrefsup22,22);	
%formred(DURTRAVrefsup23,23); 
%formred(DURTRAVrefsup24,24);	
%formred(DURTRAVrefsup25,25);  
%formred(DURTRAVrefsup26,26);	
%formred(DURTRAVrefsup27,27); 
%formred(DURTRAVrefsup28,28);	
%formred(DURTRAVrefsup29,29);	
%formred(DURTRAVrefsup30,30);
%formred(DURTRAVrefsup31,31);	
%formred(DURTRAVrefsup32,32);	
%formred(DURTRAVrefsup33,33); 
%formred(DURTRAVrefsup34,34);	
%formred(DURTRAVrefsup35,35); 
%formred(DURTRAVrefsup36,36);	
%formred(DURTRAVrefsup37,37); 
%formred(DURTRAVrefsup38,38);	
%formred(DURTRAVrefsup39,39);	
%formred(DURTRAVrefsup40,40);	
%formred(DURTRAVrefsup41,41);	
%formred(DURTRAVrefsup42,42);	
%formred(DURTRAVrefsup43,43);	
%formred(DURTRAVrefsup44,44);
%formred(DURTRAVrefsup45,45);  
%formred(DURTRAVrefsup46,46);	
%formred(DURTRAVrefsup47,47); 
%formred(DURTRAVrefsup48,48);	
%formred(DURTRAVrefsup49,49);	

data FIG8;set FigBDURTRAVrefsup15-FigBDURTRAVrefsup49; drop Parameter;
proc sort data=FIG8;by S EFFET;run;

proc export data=FIG8 outfile="c:\AER\Fig8.xls" replace;
run;


  /* Appendix Tables */
  /* Table A1 */
proc means data=DD5part;
var AGE SCO AGEcj SCOcj CADRE CADREcj SALPRIVE SALPRIVEcj;
by S cjTREATED;
title "Descriptive statistics (full sample)";
title2 "Table A1, columns 1 and 2 (Panel A and Panel B)";run;

proc means data=DD5;
var AGE SCO AGEcj SCOcj CADRE CADREcj SALPRIVE SALPRIVEcj;
by S cjTREATED;
title "Descriptive statistics (employed persons only)";
title2 "Table A1, columns 3 and 4 (Panel A and Panel B)";
run;
 

  /* Figure A1 - distribution of actual hours */
data HISTO;set DD5(keep=DURTRAVref DURTRAV S AN CADRE HH TREATED postTREATED);
length H Hu 8;H=round(DURTRAVref);
  Hu=round(DURTRAV);
length NN 6;NN=1;
    if AN in ('1997','1998');
	
proc sort data=HISTO;by S;
proc summary data=HISTO(where=(postTREATED=0 and TREATED=1)) nway ;
var NN;
class S H ;
output out=B97(drop=_TYPE_ _FREQ_) sum=;
proc print data=B97;
title "Distribution of actual hours pre-policy";
title2 "Field: Employed persons";
title3 "Source: LFS, 1997-1998, Insee. Figure A1";run;  

proc export data=B97 outfile="c:\AER\HistoH.xls" replace; run;


  /* Figure A2 - distribution of usual hours */
proc summary data=HISTO(where=(HH ne 'SP' and HH ne '  ' and postTREATED=0 and TREATED=1)) nway ;
var NN;
class S Hu;
output out=Bu97(drop=_TYPE_ _FREQ_) sum=;
proc print data=Bu97; 
title "Distribution of usual hours pre-policy";
title2 "Field : Employed persons with usual hours";
title3 "Source: LFS, 1997-1998, Insee. Figure A2";  run;

proc export data=Bu97 outfile="c:\AER\HistoHu.xls" replace;
run;

 
   /* Table C1 - avec SALRED */
data B; set A; 
length SALRED2 8;SALRED2=(exp(LOGSALRED)-1)*12/(52*6.55957);  /* weekly wage in euros */
run;

proc sort data=B;by S;
  
proc SURVEYREG data=B; 
cluster GROUPE3;
model SALRED2=DURTRAV DURDIFF SALPRIVEcj SALPRIVE  A1995-A2002 &suppvari &suppvareg;
by S;
title "Table C1 (columns 1 and 3)";

proc SURVEYREG data=B; 
cluster GROUPE3;
model SALRED2=DURTRAV DURDIFFP DURDIFFM SALPRIVEcj SALPRIVE  A1995-A2002  &suppvari &suppvareg;
by S;
title " Table C1 (columns 2 and 4)";run;


proc means data=B;
var SALRED2; by S;
title "Means for Table C1, columns 1 to 4";run;


  /* Table D1 - Public-private sector analysis */
proc SURVEYREG data=DD5(where=(SALARIE=1 and SALPRIVE=0)); 
cluster GROUPE3;
model DURTRAVref=  SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009
                 TREATEDAutre TREATED UNKNOWN PostTREATED &suppvari &suppvareg;
by S; 
title "Field : employed persons - public sector";
title2 "Reduced form , with supplementary controls &suppvareg &suppvaric";
title3 "Source : LFS, 1994-2009, Insee (Table D1, column 1)"; run;

proc SURVEYREG data=DD5(where=(SALPRIVE=1)); 
cluster GROUPE3;
model DURTRAVref=  SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009
                 TREATEDAutre TREATED UNKNOWN PostTREATED &suppvari &suppvareg;
by S; 
title "Field : employed persons - private sector"; 
title2 "Reduced form , with supplementary controls &suppvareg &suppvaric";
title3 "Source : LFS, 1994-2009, Insee (Table D1, column 2)";run;
   
proc SURVEYREG data=DD5(where=(SALPRIVE=1 and STATUT in ('24','35') and anciennete>2)); 
cluster GROUPE3;
model DURTRAVref=  SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009
                 TREATEDAutre TREATED UNKNOWN PostTREATED &suppvari &suppvareg;
by S; 
title "Field : employed persons - private sector 'protected contracts'"; 
title2 "Reduced form , with supplementary controls &suppvareg &suppvaric";
title3 "Source : LFS, 1994-2009, Insee (Table D1, column 3)";run;

proc means data=DD5(where=(SALARIE=1 and SALPRIVE=0)); 
var DURTRAVREF;  by S;
title "Means for Table D1, column 1";
proc means data=DD5(where=(SALARIE=1 and SALPRIVE=1)); 
var DURTRAVREF;  by S;
title "Means for Table D1, column 2";
proc means data=DD5(where=(SALPRIVE=1 and STATUT in ('24','35') and anciennete>2)); 
var DURTRAVREF;  by S;
title "Means for Table D1, column 3";
run;


  /* Table E2 - Falsification tests */
%let suppvaregB= NAFG16A NAFG16B NAFG16C NAFG16D NAFG16e NAFG16F NAFG16G
              NAFG16H NAFG16J NAFG16K NAFG16L NAFG16N NAFG16P NAFG16Q NAFG16R NAFG16inc;
			
proc SURVEYREG data=DD5; 
cluster GROUPE3;
model SCO=SALARIE SALPRIVE SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009
                 TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari AGE AGE2 &suppvaregB;
by S;
title "Field : employed persons";
title2 "Falsification tests for years of schooling";
title3 "Source : LFS, 1994-2009, Insee. Table E2 (column 1) - Panels A and B"; 

proc SURVEYREG data=DD5; 
cluster GROUPE3;
model AGE=SALARIE SALPRIVE SALPRIVEcj  cjTREATED PostcjTREATED A1995-A2009
                 TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari SCO  &suppvaregB ;
by S;  
title2 "Falsification tests for age";
title3 "Source : LFS, 1994-2009, Insee. Table E2 (column 2) - Panels A and B"; 

proc SURVEYREG data=DD5; 
cluster groupe3;
model SALPRIVE=SALARIE  SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009
                 TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari SCO AGE AGE2 &suppvaregB;
by S;  
title2 "Falsification tests for private sector";
title3 "Source : LFS, 1994-2009, Insee. Table E2 (column 3) - Panels A and B"; 

proc SURVEYREG data=DD5; 
cluster groupe3;
model INDUSTRIEBTP=SALARIE  SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009
                   TREATEDAutre TREATED UNKNOWN  PostTREATED &suppvari SCO AGE AGE2 ;
by S; 
title2 "Falsification tests for industry=manufacturing";
title3 "Source : LFS, 1994-2009, Insee. Table E2 (column 4) - Panels A and B"; run;

proc means data=DD5;
var SCO AGE SALPRIVE INDUSTRIEBTP; by S;
title "Means for Table E2";run;


  
  /* Table E5 - alternative sources of identification */
data DOUBLEDIF6;set DD5;	if S='1';
length postcjTREATED1 postcjTREATED2 4;
 POSTcjTREATED1=cjTREATED*(AN>'2002');
 POStcjTREATED2=postcjTREATED*(AN<='2002');
 cjTREATED1=cjTREATED*(AN in ('1998','1999','2000','2001','2002'));
run;

proc SURVEYREG data=DOUBLEDIF6; 
cluster GROUPE3;
model DURTRAVREFcj=SALPRIVEcj cjTREATED cjTREATED1 PostcjTREATED1 PostcjTREATED2 A1995-A2009 &suppvari;
title "Field: employed men";
title2 "First stage on hours";
title3 "Source : LFS, 1994-2009, Insee (Table E5, column 1)";
run;

proc SURVEYREG data=DOUBLEDIF6(where=(Ind_SALAIRE=1 )); 
cluster GROUPE3;
model LOGSALREDcj=SALPRIVEcj  cjTREATED cjTREATED1 PostcjTREATED1 PostcjTREATED2 A1995-A2009 &suppvari ;
title2 "first stage on logwages" ;
title3 "Source : LFS, 1994-2009, Insee (Table E5, column 2)"; run;

proc SURVEYREG data=DOUBLEDIF6; 
cluster GROUPE3;
model DURTRAVREF=SALARIE SALPRIVE SALPRIVEcj cjTREATED cjTREATED1 PostcjTREATED1 PostcjTREATED2 A1995-A2009 
                 TREATED TREATEDAutre UNKNOWN postTREATED  &suppvari &suppvareg;
title2 "Reduced form on hours";
title3 "Source : LFS, 1994-2009, Insee (Table E5, column 3)";
run;

proc means data=DOUBLEDIF6;
var DURTRAVREFcj DURTRAVREF; 
title "Means for Table E5, columns 1 and 3";
proc means data=DOUBLEDIF6(where=(Ind_SALAIRE=1 )); 
var LOGSALREDcj;
title "Means for Table E5, column 2";run;
