libname acooo "c:\AER\";

  /*   Program for Tables E3 and E4, web appendix   */
   
data D5part;set acooo.D5part(keep=AN S DURTRAVref DURTRAVrefcj SCOcj AGEcj AGEcj2
                                  DOUBLEDIF5 TYPEENQ IDENTNOI HH DURTRAV DURTRAVcj LOGSALRED
                                  UNTREATED Ind_SALAIRE ACTOCC
                                  NAFG16Acj NAFG16Bcj NAFG16Ccj NAFG16Dcj NAFG16ecj NAFG16Fcj NAFG16Gcj
                                  NAFG16Hcj NAFG16Jcj NAFG16Kcj NAFG16Lcj  NAFG16Ncj NAFG16Pcj NAFG16Qcj 
                                  NAFG16Rcj NAFG16inccj SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009 
                                  TREATEDAutre TREATED UNKNOWN PostTREATED SCO AGE AGE2 SALPRIVE	SALARIE 
                                  NAFG16A NAFG16B NAFG16C NAFG16D NAFG16e NAFG16F NAFG16G 	
                                  NAFG16H NAFG16J NAFG16K NAFG16L NAFG16N NAFG16P NAFG16Q NAFG16R NAFG16inc 
	                        where=('1998'<=AN<='2002'));										 
length DURDIFF 6 DURDIFF0 3;
  DURDIFF=DURTRAVREF-DURTRAV;
  DURDIFF0=(DURDIFF=0);
length DURDIFFP DURDIFFM  6;
  DURDIFFP=DURDIFF*(DURDIFF>=0); 
  DURDIFFM=DURDIFF*(DURDIFF<0);
run; 
  
proc sort data=D5part;by IDENTNOI AN;

  
data D6;set D5part(keep=IDENTNOI AN S cjTREATED postcjTREATED);by IDENTNOI AN;
length NBOBS NBcjTREATED NBpostcjTREATED 6;
 retain NBOBS NBcjTREATED NBpostcjTREATED 0;
 if first.IDENTNOI then do;NBOBS=0;NBcjTREATED=0;NBpostcjTREATED=0;end;
  NBOBS=NBOBS+1;
  NBcjTREATED=NBcjTREATED+cjTREATED;
  NBpostcjTREATED=NBpostcjTREATED+postcjTREATED;
if last.IDENTNOI;
keep IDENTNOI S NBOBS NBcjTREATED NBpostcjTREATED;
  

data DDIF5part;merge D5part D6 ;by IDENTNOI;
length GROUPE3 $ 6;	if cjTREATED=0 then GROUPE3=AN!!'00';
   else if (cjTREATED=1 and postcjTREATED=0) then GROUPE3=AN!!'10';
   else if (cjTREATED=1 and postcjTREATED=1) then GROUPE3=AN!!'11';
run;

proc sort data=DDIF5part;by S NBOBS;
proc freq data=DDIF5part;
tables NBOBS ; by S;
proc freq; tables NBcjTREATED*NBpostcjTREATED /list missing;
by S NBOBS;
title "Number of observations - Table E3 (columns 1 to 3)";run;

proc sort data=DDIF5part;by S IDENTNOI;

data DDIF5;set DDIF5part(where=(DOUBLEDIF5=1));run;
 

proc sort data=DDIF5;by S IDENTNOI;run;

    	
     /* Table E4 - 1998-2002 */
proc STANDARD data=DDIF5part out=DD5partSTAN MEAN=0;
var ACTOCC SALPRIVEcj cjTREATED PostcjTREATED A1999-A2002 SCOcj AGEcj AGEcj2 SCO AGE AGE2;
by S IDENTNOI;        

proc SURVEYREG data=DD5partSTAN; 
cluster IDENTNOI;
model ACTOCC=SALPRIVEcj cjTREATED PostcjTREATED A1999-A2002 SCOcj AGEcj AGEcj2 SCO AGE AGE2;
by S;
title "Field : full sample";
title2 "Reduced form on employment";
title3 "with supplementary controls : SCOcj AGEcj AGEcj2 SCO AGE AGE2";
title4 "Source : LFS, 1998-2002, Insee (Table E4, column 1)";run;

proc means data= DDIF5part;
var ACTOCC;by S;
title "Mean for Table E4, column 1";run;


proc standard data=DDIF5(where=(SALARIE=1)) out=DD5STAN MEAN=0;
var LOGSALRED DURTRAVREF SALPRIVE SALPRIVEcj cjTREATED postcjTREATED  A1999-A2002 
    TREATEDAutre TREATED UNKNOWN PostTREATED SCOcj AGEcj AGEcj2 NAFG16Acj NAFG16Bcj NAFG16Ccj NAFG16Dcj NAFG16ecj NAFG16Fcj NAFG16Gcj
    NAFG16Hcj NAFG16Jcj NAFG16Kcj NAFG16Lcj  NAFG16Ncj NAFG16Pcj NAFG16Qcj NAFG16Rcj NAFG16inccj  
    SCO AGE AGE2 NAFG16A NAFG16B NAFG16C NAFG16D NAFG16e NAFG16F NAFG16G
    NAFG16H NAFG16J NAFG16K NAFG16L   NAFG16N NAFG16P NAFG16Q NAFG16R NAFG16inc;
by S IDENTNOI;  

proc SURVEYREG data=DD5STAN;
cluster IDENTNOI;
model DURTRAVREF=SALPRIVE SALPRIVEcj cjTREATED postcjTREATED  A1999-A2002 
                 TREATEDAutre TREATED UNKNOWN PostTREATED SCOcj AGEcj AGEcj2 NAFG16Acj NAFG16Bcj NAFG16Ccj NAFG16Dcj NAFG16ecj NAFG16Fcj NAFG16Gcj
                 NAFG16Hcj NAFG16Jcj NAFG16Kcj NAFG16Lcj  NAFG16Ncj NAFG16Pcj NAFG16Qcj NAFG16Rcj NAFG16inccj  
                 SCO AGE AGE2 NAFG16A NAFG16B NAFG16C NAFG16D NAFG16e NAFG16F NAFG16G
                 NAFG16H NAFG16J NAFG16K NAFG16L   NAFG16N NAFG16P NAFG16Q NAFG16R NAFG16inc;
by S;
title "Field : employed persons ";
title2 "Reduced form on hours"; 
title3 "with supplementary controls : SCOcj AGEcj AGEcj2 SCO AGE AGE2 and industries";
title4 "Source : LFS, 1998-2002, Insee (Table E4, column 2)"; run;


proc SURVEYREG data=DD5STAN;
cluster IDENTNOI;
model LOGSALRED=SALPRIVE SALPRIVEcj cjTREATED  postcjTREATED   A1999-A2002 
               TREATEDAutre TREATED UNKNOWN PostTREATED AGEcj AGEcj2 NAFG16Acj NAFG16Bcj NAFG16Ccj NAFG16Dcj NAFG16ecj NAFG16Fcj NAFG16Gcj
               NAFG16Hcj NAFG16Jcj NAFG16Kcj NAFG16Lcj  NAFG16Ncj NAFG16Pcj NAFG16Qcj NAFG16Rcj NAFG16inccj 
                SCO AGE AGE2 NAFG16A NAFG16B NAFG16C NAFG16D NAFG16e NAFG16F NAFG16G
                 NAFG16H NAFG16J NAFG16K NAFG16L   NAFG16N NAFG16P NAFG16Q NAFG16R NAFG16inc;
by S;  
title2 "Reduced form on log wages";
title3 "with supplementary controls (Table E4, column 3)";
title4 "Source : LFS, 1998-2002, Insee "; run;

proc means data= DDIF5(where=(SALARIE=1));
var DURTRAVREF LOGSALRED; by S;
title "Mean for Table E4, columns 2 and 3";run;

  
 
   /* Table E4, columns 4 to 7*/
proc standard data=DDIF5(where=(SALARIE=1 and HH ne 'SP' and HH ne ' ')) out=DD5STANb MEAN=0;
var SALPRIVE SALPRIVEcj cjTREATED postcjTREATED   A1999-A2002 	DURTRAV DURDIFF DURDIFFP DURDIFFM
    TREATEDAutre TREATED UNKNOWN PostTREATED SCOcj AGEcj AGEcj2 NAFG16Acj NAFG16Bcj NAFG16Ccj NAFG16Dcj NAFG16ecj NAFG16Fcj NAFG16Gcj
    NAFG16Hcj NAFG16Jcj NAFG16Kcj NAFG16Lcj  NAFG16Ncj NAFG16Pcj NAFG16Qcj NAFG16Rcj NAFG16inccj  
    SCO AGE AGE2 NAFG16A NAFG16B NAFG16C NAFG16D NAFG16e NAFG16F NAFG16G
    NAFG16H NAFG16J NAFG16K NAFG16L   NAFG16N NAFG16P NAFG16Q NAFG16R NAFG16inc;
by S IDENTNOI;  

proc SURVEYREG data=DD5STANb;
cluster IDENTNOI; 
model DURTRAV=SALPRIVE SALPRIVEcj cjTREATED  postcjTREATED    A1999-A2002 
              TREATEDAutre TREATED UNKNOWN PostTREATED AGEcj AGEcj2 NAFG16Acj NAFG16Bcj NAFG16Ccj NAFG16Dcj NAFG16ecj NAFG16Fcj NAFG16Gcj
              NAFG16Hcj NAFG16Jcj NAFG16Kcj NAFG16Lcj  NAFG16Ncj NAFG16Pcj NAFG16Qcj NAFG16Rcj NAFG16inccj 
              SCO AGE AGE2 NAFG16A NAFG16B NAFG16C NAFG16D NAFG16e NAFG16F NAFG16G
              NAFG16H NAFG16J NAFG16K NAFG16L   NAFG16N NAFG16P NAFG16Q NAFG16R NAFG16inc ;
by S;
title "Field : employed persons with usual hours";
title2 "Reduced form on DURTRAV, with supplementary controls (Table E4, column 4)";
title3 "Source : LFS, 1998-2002, Insee "; run;

proc SURVEYREG data=DD5STANb;
cluster IDENTNOI;
model DURDIFF= SALPRIVE SALPRIVEcj cjTREATED  postcjTREATED   A1999-A2002 
               TREATEDAutre TREATED UNKNOWN PostTREATED AGEcj AGEcj2 NAFG16Acj NAFG16Bcj NAFG16Ccj NAFG16Dcj NAFG16ecj NAFG16Fcj NAFG16Gcj
               NAFG16Hcj NAFG16Jcj NAFG16Kcj NAFG16Lcj  NAFG16Ncj NAFG16Pcj NAFG16Qcj NAFG16Rcj NAFG16inccj
                 SCO AGE AGE2 NAFG16A NAFG16B NAFG16C NAFG16D NAFG16e NAFG16F NAFG16G
                 NAFG16H NAFG16J NAFG16K NAFG16L   NAFG16N NAFG16P NAFG16Q NAFG16R NAFG16inc;
by S;
title2 "Reduced form on DURDIFF, with supplementary controls (Table E4, column 5)";
title3 "Source : LFS, 1998-2002, Insee "; run;

proc SURVEYREG data=DD5STANb;
cluster IDENTNOI;
model DURDIFFP=SALARIE SALPRIVE SALPRIVEcj cjTREATED  postcjTREATED   A1999-A2002 
               TREATEDAutre TREATED UNKNOWN PostTREATED AGEcj AGEcj2 NAFG16Acj NAFG16Bcj NAFG16Ccj NAFG16Dcj NAFG16ecj NAFG16Fcj NAFG16Gcj
               NAFG16Hcj NAFG16Jcj NAFG16Kcj NAFG16Lcj  NAFG16Ncj NAFG16Pcj NAFG16Qcj NAFG16Rcj NAFG16inccj 
                 SCO AGE AGE2 NAFG16A NAFG16B NAFG16C NAFG16D NAFG16e NAFG16F NAFG16G
                 NAFG16H NAFG16J NAFG16K NAFG16L   NAFG16N NAFG16P NAFG16Q NAFG16R NAFG16inc ;
by S;
title2 "Reduced form on DURDIFFP, with supplementary controls (Table E4, column 6)";
title3 "Source : LFS, 1998-2002, Insee "; run;

proc SURVEYREG data=DD5STANb;
cluster IDENTNOI;
model DURDIFFM=SALARIE SALPRIVE SALPRIVEcj cjTREATED  postcjTREATED   A1999-A2002 
               TREATEDAutre TREATED UNKNOWN PostTREATED AGEcj AGEcj2 NAFG16Acj NAFG16Bcj NAFG16Ccj NAFG16Dcj NAFG16ecj NAFG16Fcj NAFG16Gcj
               NAFG16Hcj NAFG16Jcj NAFG16Kcj NAFG16Lcj  NAFG16Ncj NAFG16Pcj NAFG16Qcj NAFG16Rcj NAFG16inccj   
                 SCO AGE AGE2 NAFG16A NAFG16B NAFG16C NAFG16D NAFG16e NAFG16F NAFG16G
                 NAFG16H NAFG16J NAFG16K NAFG16L   NAFG16N NAFG16P NAFG16Q NAFG16R NAFG16inc ;
by S;
title2 "Reduced form on DURDIFFM, with supplementary controls (Table E4, column 7)";
title3 "Source : LFS, 1998-2002, Insee "; run;

proc means data=DDIF5(where=(SALARIE=1 and HH ne 'SP' and HH ne ' '));
var DURTRAV DURDIFF DURDIFFP DURDIFFM; by S;
title "Means for Table E4, columns 4 to 7";run;
